<?
	// File        : /admin/index.php
	//
	// Description : Administrator login page.

	
	// Include the system configuration file
	include_once ( '../conf/config.inc.php' );

	// Include the main include file for running all routine.
	include_once ( $CONF_INCLUDE_PATH.'/library.inc.php' );

	// Include the ADOdb Class
	include_once ( $CONF_INCLUDE_PATH.'/adodb/adodb.inc.php');

	// Include the main include file for running all routine.
	include_once ( $CONF_INCLUDE_PATH.'/lib-themes.inc.php' );



	// Save the session file into a specific folder
	session_save_path ( $CONF_ADMIN_SESSION_PATH );

	// Change the session name to SSID
	session_name ( 'SSID' );

	// Start session
	session_start();

	// Upcase the variable $action
	$action = strtoupper ( $action );


	header("Cache-Control: no-store, no-cache, must-revalidate");
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Pragma: no-cache");


	if ( $action!='LOGOUT' && session_is_registered("SESS_ADM_LOGIN_ID") )
	{
		// The administrator is not logined, not allow he/she run this.
		header("Location: $CONF_ADMIN_URL/modules.php?");

		exit;
	}


	// The administrator request logout
	if ( $action=='LOGOUT' && session_is_registered("SESS_ADM_LOGIN_ID") )
	{
		// --------------------------------------
		// --- Save the logout event into LOG ---
		// --------------------------------------
		$db = ADONewConnection(db2adodb($CONF_DATABASE_TYPE));
		$db->debug = false;
		if ( chkDBIsODBC($CONF_DATABASE_TYPE) )
		{
			// The server type is ODBC, remove PORT setting
			// ...................
			// ..................
		}
		else
		{
			// Check the sql server with different port
			if ( $CONF_DATABASE_PORT )
				$sqlServer = $CONF_DATABASE_ADDR.":".$CONF_DATABASE_PORT;
			else
				$sqlServer = $CONF_DATABASE_ADDR;
		}

		// If user provide the database name, auto change to that database.
		if ( $DATABASE_DBNAME )
			$db->database = $CONF_DATABASE_DBNAME;

		// Create Connection
		@ $conn = $db->PConnect($sqlServer, $CONF_DATABASE_ID, $CONF_DATABASE_PWD);
		
		if ( $conn )
		{
			$currentDateTime = date("Y-m-d H:i:s");
			$eventCode = 501;
			$SID = session_id();
			$eventMsg = "Administrator $SESS_ADM_NAME(LOGIN ID=$SESS_ADM_LOGIN_ID) logout success, session=$SID";
			$nextID = $db->GenID('log_id_seq');
			$query = "INSERT INTO log VALUES ('$nextID', '$eventCode', '$currentDateTime', '$eventMsg', '$SESS_ID')";

			// Save the LOG into database
			@ $db->Execute($query);
		}
		$db->close();
		// --------------------------------------
		// ---------------- END -----------------
		// --------------------------------------


		// Destroy all session
		session_unregister ( "sess_admLoginID" );
		session_unset();
		session_destroy();
		// Redirect to login page
		Header ( 'Location: '.$CONF_ADMIN_URL.'/?' );

		// Exit the logout process
		exit;
	}
	// Display admin login page
	else
	{
		if ( isset($frm_submit) || (($adminID!='') && ($adminPwd!='')) )
		{
			// --- Check the login ---
			
			GLOBAL 
				$WRONGPASSWORD;			// Wrong Password Flag

			// This flag store the login is allow or NOT
			$loginAllow = FALSE;

			if ( ($adminID!='') && ($adminPwd!='') )
			{
				// *** Check the admin ID and password is correct ***
				
				if ( $CONF_FORGET_ROOT_PWD )
				{
					// The $FORGET_ROOT_PWD is set, then check the default ID and password
					if ( ( strcmp($adminID,'rootAdmin') == 0 ) && ( strcmp($adminPwd,'rootPassword') == 0 ) )
						$loginAllow = TRUE;
					else
						$WRONGPASSWORD = TRUE;
				}
				else
				{
					// --- Do check the admin ID and password store in SQL database ---

					// Check the current magic_quotes setting
					if ( get_magic_quotes_gpc() )
					{
						// Un-quote string (by default, magic_quotes is ON)
						$adminID	= stripslashes ( $adminID );
						$adminPwd	= stripslashes ( $adminPwd );
					}
					else
					{
						// Un-quote string (by default, magic_quotes is ON)
						$adminID	= addslashes ( $adminID );
						$adminPwd	= addslashes ( $adminPwd );
					}

					// Encrypt the entered password
					$encyptPwd = encryptString ($adminPwd, 250);

					// Sleep for 1 secode to prevent DOS (Deny of services) attack
					sleep(1);
					
					// Connect to the SQL server using ADOdb library
					$db = ADONewConnection(db2adodb($CONF_DATABASE_TYPE));
					$db->debug = false;
					if ( chkDBIsODBC($CONF_DATABASE_TYPE) )
					{
						// The server type is ODBC, remove PORT setting
						// ...................
						// ..................
					}
					else
					{
						// Check the sql server with different port
						if ( $CONF_DATABASE_PORT )
							$sqlServer = $CONF_DATABASE_ADDR.":".$CONF_DATABASE_PORT;
						else
							$sqlServer = $CONF_DATABASE_ADDR;
					}

					// If user provide the database name, auto change to that database.
					if ( $CONF_DATABASE_DBNAME )
						$db->database = $CONF_DATABASE_DBNAME;

					// Create Connection
					@ $conn = $db->PConnect($sqlServer, $CONF_DATABASE_ID, $CONF_DATABASE_PWD);

					// Display the connection result
					if ( !$conn )
					{
						// -- Connection Error --
						// If the ErrorMsg() store some error message, display it
						if ( $db->ErrorMsg() )
						{
							echo $db->ErrorMsg()."<br><br>\n";
							exit;
						}
						else
							// Check connection
							echo $DATABASE_ERR_REASONALL.'<BR><BR>'."\n";
					}
					else
					{
						$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
						
						// -- Connect to DB Success --
						$query = "SELECT * FROM adm_users WHERE adm_login_id='$adminID' AND adm_login_passwd='$encyptPwd' AND ac_enable='Y'";

						// execute the query
						if ( !$rs = $db->Execute($query) )
						{
							// Error on select from table
							echo  $db->ErrorMsg()."<br>\n";
							exit;
						}

						// check the result
						$numrows = 0;
						$numrows = $rs->PO_RecordCount( 'adm_users');

						if ( $numrows == 1 )
						{
							// The adminID and password verified, save the admin account
							// information into session
							/*
								SESS_ID
								SESS_AC_ENABLE
								SESS_PARENT
								SESS_ADM_LOGIN_ID
								SESS_ADM_LOGIN_PASSWD
								SESS_ADM_NAME
								SESS_ADM_DESCRIBE
								SESS_ADM_EMAIL
								SESS_ADM_GROUP
								SESS_DEFAULT_LANG
								SESS_DEFAULT_THEMES
								SESS_CREATE_DATE
								SESS_EXPIRE_DATE_TIME
								SESS_IP_ACCESS_LIST
								SESS_IP_DENY_LIST
								SESS_MODULES_ALLOW
							*/
							$fetchArray = $rs->fields;
							$fetchArrayFlip = array_keys($fetchArray);
							foreach ( $fetchArrayFlip as $arrayName )
							{
								$sess_var_name  = 'SESS_'.strtoupper( $arrayName );
								$$sess_var_name = noDoubleSpace( $fetchArray[$arrayName] );
								session_register ($sess_var_name);

							}

							// Perpare the LOG
							$currentDateTime = date("Y-m-d H:i:s");
							$eventCode = 500;
							$SID = session_id();
							$eventMsg = "Administrator $SESS_ADM_NAME(LOGIN ID=$SESS_ADM_LOGIN_ID) login successful, session=$SID";
							// --- End ---

							/*
							echo '$SESS_ID = '.$SESS_ID.' : ('.strlen($SESS_ID).')'."<br>\n";
							echo '$SESS_AC_ENABLE = '.$SESS_AC_ENABLE.' : ('.strlen($SESS_AC_ENABLE).')'."<br>\n";
							echo '$SESS_PARENT = '.$SESS_PARENT.' : ('.strlen($SESS_PARENT).')'."<br>\n";
							echo '$SESS_ADM_LOGIN_ID = '.$SESS_ADM_LOGIN_ID.' : ('.strlen($SESS_ADM_LOGIN_ID).')'."<br>\n";
							echo '$SESS_ADM_LOGIN_PASSWD = '.$SESS_ADM_LOGIN_PASSWD.' : ('.strlen($SESS_ADM_LOGIN_PASSWD).')'."<br>\n";
							echo '$SESS_ADM_NAME = '.$SESS_ADM_NAME.' : ('.strlen($SESS_ADM_NAME).')'."<br>\n";
							echo '$SESS_ADM_DESCRIBE = '.$SESS_ADM_DESCRIBE.' : ('.strlen($SESS_ADM_DESCRIBE).')'."<br>\n";
							echo '$SESS_ADM_EMAIL = '.$SESS_ADM_EMAIL.' : ('.strlen($SESS_ADM_EMAIL).')'."<br>\n";
							echo '$SESS_ADM_GROUP = '.$SESS_ADM_GROUP.' : ('.strlen($SESS_ADM_GROUP).')'."<br>\n";
							echo '$SESS_DEFAULT_LANG = '.$SESS_DEFAULT_LANG.' : ('.strlen($SESS_DEFAULT_LANG).')'."<br>\n";
							echo '$SESS_DEFAULT_THEMES = '.$SESS_DEFAULT_THEMES.' : ('.strlen($SESS_DEFAULT_THEMES).')'."<br>\n";
							echo '$SESS_CREATE_DATE = '.$SESS_CREATE_DATE.' : ('.strlen($SESS_CREATE_DATE).')'."<br>\n";
							echo '$SESS_EXPIRE_DATE_TIME = '.$SESS_EXPIRE_DATE_TIME.' : ('.strlen($SESS_EXPIRE_DATE_TIME).')'."<br>\n";
							echo '$SESS_IP_ACCESS_LIST = '.$SESS_IP_ACCESS_LIST.' : ('.strlen($SESS_IP_ACCESS_LIST).')'."<br>\n";
							echo '$SESS_IP_DENY_LIST = '.$SESS_IP_DENY_LIST.' : ('.strlen($SESS_IP_DENY_LIST).')'."<br>\n";
							echo '$SESS_MODULES_ALLOW = '.$SESS_MODULES_ALLOW.' : ('.strlen($SESS_MODULES_ALLOW).')'."<br>\n";
							*/
							
						}
						else
						{
							// --- Login process fail ---

							// Perpare the LOG
							$currentDateTime = date("Y-m-d H:i:s");
							$eventCode = 502;
							$SID = session_id();
							$eventMsg = "Administrator login failed (id=$adminID,pwd=$adminPwd), session=$SID";
						}


						// -------------------------------
						// --- Save the event into LOG ---
						// -------------------------------
						// Get the next avaliable ID (key)
						$nextID = $db->GenID('log_id_seq');

						// Perpare the Query of create the administrator
						$query = "INSERT INTO log VALUES ('$nextID', '$eventCode', '$currentDateTime', '$eventMsg', '$SESS_ID')";

						// Save the LOG into database
						@ $db->Execute($query);
						$db->close();
						// -------------------------------
						// ------------ END --------------
						// -------------------------------
						

						if ( $numrows == 1 )
						{
							// The adminID and password verified, redirect him to logined page
							Header ( 'Location: '.$CONF_ADMIN_URL.'/?' );
							exit;
						}

					}
				}


				if ( !$loginAllow )
				{
					// user ID or Password is empty, show WrongPassword
					$WRONGPASSWORD = TRUE;
				}
			}
		}
		elseif ( isset($action) && $action!='LOGIN' && $action!='SUBMIT' )
		{
			// Redirect to login page
			Header ( 'Location: '.$CONF_ADMIN_URL.'/?action=login' );
			exit;
		}


		// -----------------------------------
		// --------- Check the themes --------
		// -----------------------------------
		$themeName = chkTheme( $SESS_DEFAULT_THEMES, $CONF_DEFAULT_ADMIN_THEMES );
		if ( !isset($themeName) || $themeName=='' )
		{
			// Can't found the themes for display
			echo "<br><br><center>\n";
			echo "Error!! System can not found the default theme set. Please content your administrator.</center><br><br>\n";
			exit;
		}
		else
		{
			// Loading the Themes
			$theme = new myTheme( $themeName, $SESS_DEFAULT_LANG );
			$theme->debug=0;
			$theme->isAdmin=1;
			$theme->getTemplate('login');
			$theme->assign( 'PROGRAM_NAME', $CONF_SERVER_NAME );
			$theme->assign( 'PROGRAM_VER', $CONF_SERVER_VER );
			$theme->assign( 'OES_URL', $CONF_OES_URL );
			$theme->assign( 'TXT_LICENSE', 'GNU Public License @ 2003' );
			
			// Display if the user type wrong password
			if ( $WRONGPASSWORD )
				$theme->assign( 'WRONG_PASSWORD', 'LANG=WRONGPASSWORD' );
			else
				$theme->assign( 'WRONG_PASSWORD', '' );

			// The login box will larger when the browser support CSS
			if ( cssSupport() )
				$theme->assign( 'LOGIN_BOX_SIZE', '24' );
			else
				$theme->assign( 'LOGIN_BOX_SIZE', '15' );

			$theme->getHeader();
			echo $theme->getResult();
		}
	}

?>