<?
	// File        : /admin/modules.php
	//
	// Description : Administrator modules page.

	
	// Include the system configuration file
	include_once ( '../conf/config.inc.php' );

	// Include the main include file for running all routine.
	include_once ( $CONF_INCLUDE_PATH.'/library.inc.php' );

	// Include the main include file for running all routine.
	include_once ( $CONF_INCLUDE_PATH.'/lib-themes.inc.php' );

	// Include the template systtem for modules.
	include_once ( $CONF_INCLUDE_PATH.'/lib-template-mod.inc.php' );


	// Save the session file into a specific folder
	session_save_path ( $CONF_ADMIN_SESSION_PATH );

	// Change the session name to SSID
	session_name ( 'SSID' );

	// Start session
	session_start();


	//--------------------------------------------------------
	// Define Constant Area
	//--------------------------------------------------------
	define( 'ROW_MODULES_NUM', 4,											TRUE );
	define( 'THIS_FILE_NAME' , './modules.php',								TRUE );
	define( 'FILE_PHP_LINK'  , './file.php?mode=load&nolimit=&file=modules/',TRUE );

	//--------------------------------------------------------


	if ( !session_is_registered("SESS_ADM_LOGIN_ID") )
	{
		//--------------------------------------------------------
		// The administrator is not logined, not allow he/she run this.
		// and redirect he/she got login page
		//--------------------------------------------------------
		header("Location: $CONF_ADMIN_URL/?action=logout");
	}
	else
	{
		//--------------------------------------------------------
		// The administrator is logined, loading the logined page
		//--------------------------------------------------------

		// If the timeout is set, redirect the administrator to logout page
		// if he/she don't click anything within some time.
		if ( $CONF_ADMIN_SESSION_TIMEOUT )
		{
			// Send the time-out header
			header("Refresh: $CONF_ADMIN_SESSION_TIMEOUT; URL=$CONF_ADMIN_URL/?action=logout");
		}


		// Check which category did the user selected
		$category = strtolower($category);
		switch ( $category )
		{
			case 'user_account'	: $category = 'user_account'; break;
			case 'system'		: $category = 'system'; break;
			case 'modules'		: $category = 'modules'; break;
			case 'support'		: $category = 'support'; break;
			case 'oes'			: $category = 'oes'; break;
			default				: header("Location: ".THIS_FILE_NAME."?category=oes");
		}

		// Set the category path
		$category_path = $CONF_ADMIN_MODULES_PATH.'/'.$category;

		// Check the logined administrator allow go with which modules
		$categoryAllow = explode( '|', $SESS_MODULES_ALLOW );
		for ( $i=0; $i<count($categoryAllow); $i++ )
		{
			if ( $categoryAllow[$i] )
			{
				$cat = explode( ':', $categoryAllow[$i] );
				$modAllow[$cat[0]] = explode( ',', $cat[1] );
			}
		}


		// When user click the modules, check is it avaliable?
		// if not, redirect user goto the current category main page
		if ( isset($mod) && $mod!='' )
		{
			$modList = explode( '|', $mod );

			if ( count($modList) )
				$mod = $modList[0];

			// This account is not allow to go this modules
			if ( (!is_array($modAllow[$category]) || !in_array($mod, $modAllow[$category])) && $SESS_ID!=1)
			{
				// Not allow the administrator to execulate the modules, redirect
				// he/she goto the first page.
				header("Location: ".THIS_FILE_NAME.'?category='.$category);
				exit;
			}
			else
			{
				// If the modules is avaliable, execulate it
				if ( !@include($category_path.'/'.$mod.'/module.php') )
				{
					// The modules is not avaliable,
					// redirect user goto the current category
					header("Location: ".THIS_FILE_NAME.'?category='.$category);

					exit;
				}
			}
		}


		// ---------------------------------------------------------------------- //
		// Display the html header part first
		// ---------------------------------------------------------------------- //
		// If no set the admin default language, set to english
		if ( !$SESS_DEFAULT_LANG )
		{
			$SESS_DEFAULT_LANG = 'en';
			session_register('SESS_DEFAULT_LANG');
		}

		// Check the current theme
		if ( !session_is_registered('SESS_CURRENT_THEME') )
		{
			$CURRENT_THEME = chkTheme( $SESS_DEFAULT_THEMES, $SESS_DEFAULT_LANG );
			$SESS_CURRENT_THEME = $CURRENT_THEME;
			session_register('SESS_CURRENT_THEME');
		}
		else
			$CURRENT_THEME = $SESS_CURRENT_THEME;

		// Create themes object
		$theme = new myTheme( $CURRENT_THEME, $SESS_DEFAULT_LANG );
		$theme->debug=0;
		$theme->isAdmin=1;
		$theme->getTemplate('header');

		// Do the dynamic string replacement
		$theme->assign( 'SUB_TITLE', 'LANG='.strtoupper($category) );
		$theme->assign( 'SUB_TITLE_URL', THIS_FILE_NAME.'?category='.$category );
		$theme->assign( 'PROGRAM_NAME', $CONF_SERVER_NAME );
		$theme->assign( 'PROGRAM_VER', $CONF_SERVER_VER );
		// ---------------------------------------------------------------------- //


		// ---------------------------------------------------------------------- //
		// execulate the modules when it was clicked
		// ---------------------------------------------------------------------- //
		if ( isset($mod) && $mod!='' )
		{
			// store the modules valiable into array
			// '$modulesList[modules_name][modules_valiable]'
			foreach ( array_keys($MODULES) as $modKeyConf )
				$modulesList[$mod][$modKeyConf] = $MODULES[$modKeyConf];

			// Try include the language file for this module
			$modLang = $category_path.'/'.$mod.$modulesList[$mod]['LANG_DIR'].'/'.$SESS_DEFAULT_LANG.'.lang.php';
			if ( @include($modLang) )
				$SESS_CURRENT_LANG = $SESS_DEFAULT_LANG;
			else
			{
				// Can't use the user defined language for this modules,
				// it will try to use the theme default language
				$modLang = $category_path.'/'.$mod.$modulesList[$mod]['LANG_DIR'].'/'.$THEMES_DEFAULT_LANG.'.lang.php';
				if ( @include($modLang) )
					$SESS_CURRENT_LANG = $THEMES_DEFAULT_LANG;
				else
				{
					// can't use the theme default language for this modules,
					// it will use the default language 'English'
					$modLang = $category_path.'/'.$mod.$modulesList[$mod]['LANG_DIR'].'/en.lang.php';
					$SESS_CURRENT_LANG = $modulesList[$mod]['LANG_DIR'];
					@include( $modLang );
				}
			}

			// Save the current language
			session_register ('SESS_CURRENT_LANG');

			// The full URL query path of
			$URL_QUERY = THIS_FILE_NAME.'?category='.$category.'&mod='.$mod;


			// -------------------------------------------- //
			// Load the header and the menu first
			// Set the sub modules link
			$subModulesLink = '<a href="'.THIS_FILE_NAME.'?category='.$category.'&mod='.$mod.'"> '.eregi_replace( '<br>', '', $MODLANG["MODULE_NAME"] ).' </a>';

			// Display a sub modules quick link in the sub title area
			// (This is a experimater function, version 0.1 only allow 1 level of sub modules,
			//  i.e. "Category > Modules Name > Sub Modules" and no more)
			if ( count($modList) )
				for ( $i=1; $i<count($modList); $i++ )
//					$subModulesLink .= ' > <a href="'.$_SERVER["REQUEST_URI"].'"> '.eregi_replace( '<br>', '',$modList[$i] ).' </a>';
					$subModulesLink .= ' > <a href="'.$PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action='.$action.'"> '.eregi_replace( '<br>', '',$modList[$i] ).' </a>';

//			$subModulesLink = '<a href="'.THIS_FILE_NAME.'?category='.$category.'&mod='.$mod.'"> '.eregi_replace( '<br>', '', $MODLANG["MODULE_NAME"] ).' </a>';
			// -------------------------------------------- //

			$theme->assign( 'SUB_MODULES', ' > '.$subModulesLink );
			$theme->getHeader();
			echo $theme->getResult();

			// Include the modules execulation file
			$modPath = $category_path.'/'.$mod;
			include ( $modPath.'/'.$modulesList[$mod]['EXECUTION_FILE'] );
		}
		else
		{
			// Not click the modules, display the category page and let
			// the user choose which modules in the category to be execulate

			// Load the header and the menu first
			$theme->assign( 'SUB_MODULES', '' );
			$theme->getHeader();
			echo $theme->getResult();

			//--------------------------------------------------------
			// Check which modules is avaliable on this category
			//--------------------------------------------------------

			// Try to open the modules directory
			if ( @$d = dir( $category_path ) )
			{
				// read the sub directory of this category
				while (false !== ($entry = $d->read())) {
					if ( $entry != "." && $entry != ".." && is_dir($category_path.'/'.$entry) )
						// Only display the modules which the administrator is allow to enter
						if ( is_array($modAllow[$category]) && in_array( $entry, $modAllow[$category] ) || $SESS_ID<=1)
							$modulesList[$entry] = '';
				}
				$d->close();
				if ( !count($modulesList) )
				{
					// Display none of modules in this category
					$theme->getTemplate('error_msg');
					$theme->assign( 'ERROR_MSG', 'LANG=NO_MODULES' );
					echo $theme->getResult();
				}
				else
				{
					// Sort the modules name
					ksort( $modulesList );

					// Check each sub directory is it a valid modules
					foreach ( array_keys($modulesList) as $mod )
					{
						// try to include the configuration file of each modules
						// if success, also store the valiable into array
						// '$modulesList[modules_name][modules_valiable]'
						if ( @include($category_path.'/'.$mod.'/module.php') )
							foreach ( array_keys($MODULES) as $modKeyConf )
								$modulesList[$mod][$modKeyConf] = $MODULES[$modKeyConf];
						else
							// this sub directory is not a valid modules
							// remove it from the array
							unset ( $modulesList[$mod] );
					}

					// Don't do the fillowing part if none of modules in this category
					if ( !count (array_keys($modulesList)) )
						break;

					echo "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\">\n";
					echo "<tr>\n";

					// Dumps all modules contain in this category on the screen
					$i = 1;
					$colNum = 1;
					foreach ( array_keys($modulesList) as $mod )
					{
						// Define the image path
						$imgPath = FILE_PHP_LINK.$category.'/'.$mod;
						$urlLink = THIS_FILE_NAME.'?category='.$category.'&mod='.$mod;

						// Display the row
						echo "   <td width=\"".(100/ROW_MODULES_NUM)."%\" align=\"center\" valign=\"top\">\n";
						echo "      <table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\" valign=\"top\">\n";

						// Display the javascript, mouse over.
						// if the module have two set image icon
						if ( $modulesList[$mod]['ICON_MOUSEOVER'] )
							$onMouseOver =  "onMouseOut=\"MM_swapImgRestore()\" onMouseOver=\"MM_swapImage('mod-".$i."','','".$imgPath.$modulesList[$mod]['ICON_MOUSEOVER']."',1)\"";
						else
							$onMouseOver = '';

						// Display the modules name with different language
						if ( @include($category_path.'/'.$mod.'/'.$modulesList[$mod]['LANG_DIR'].'/'.$SESS_DEFAULT_LANG.'.lang.php') )
							// try the admin user prefered language first
							$modName = $MODLANG["MODULE_NAME"];
						else
							// all false, use the name defined in the modules configuration file
							$modName = $modulesList[$mod]['NAME'];


						// Display the modules icon and link
						echo '      <tr><td align="center"><a href="'.$urlLink.'" '.$onMouseOver.'><img src="'.$imgPath.$modulesList[$mod]['ICON_MOUSEOUT'].'" alt="'.$modulesList[$mod]['NAME'].'" name="mod-'.$i.'" width="80" height="60" border="0">'."\n";
						echo '      <tr><td align="center"><a href="'.$urlLink.'" '.$onMouseOver.'><font class="font">'.$modName.'</font></a></td></tr>'."\n";
						echo "      </td></tr></table>\n";
						echo "   </td>\n";

						// Display the empty block on the last row
						if ( ($i == count(array_keys($modulesList))) && ($colspan = ( ceil ($i/ROW_MODULES_NUM) * ROW_MODULES_NUM ) - $i ) )
							for ($x=0; $x<$colspan; $x++) 
								echo "   <td width=\"25%\">&nbsp;</td>\n";

						// Print out the html table link break if meet the column
						// limit of each row. (i.e. the limit is set by 'ROW_MODULES_NUM')
						if ( $colNum >= ROW_MODULES_NUM )
						{
							echo "</tr>\n";
							echo "<tr><td height=\"10px\" colspan=\"".ROW_MODULES_NUM."\">&nbsp;</td></tr>\n";
							echo "<tr>\n";
							$colNum = 0;
						}

						// Counter
						$i++;
						$colNum++;
					}

					echo "</tr>\n";
					echo "</table>\n";
				}
			}
			else
			{
				// Display none of modules in this category
				$theme->getTemplate('error_msg');
				$theme->assign( 'ERROR_MSG', 'LANG=NO_MODULES' );
				echo $theme->getResult();
			}
			//--------------------------------------------------------
			// End of check modules in a category
			//--------------------------------------------------------
		}
		// ---------------------------------------------------------------------- //



		// ---------------------------------------------------------------------- //
		// Display the html footer part
		// ---------------------------------------------------------------------- //
		// Load the footer
		$theme = new myTheme( $CURRENT_THEME, $THEMES_DEFAULT_LANG );
		$theme->debug=0;
		$theme->isAdmin=1;
		$theme->getTemplate('footer');
		$theme->assign( 'PROGRAM_NAME', $CONF_SERVER_NAME );
		$theme->assign( 'PROGRAM_VER', $CONF_SERVER_VER );
		$theme->assign( 'OES_URL', $CONF_OES_URL );
		$theme->assign( 'TXT_LICENSE', 'GNU Public License @ 2003' );
		echo $theme->getResult();
		// ---------------------------------------------------------------------- //
	}
?>