<?php
	// File        : /include/lib-group.inc.php
	//
	// Description : This library is used for create/edit/view the group info.


	// Include the configuration file.
	include_once ( $CONF_CONFIG_PATH.'/config.inc.php' );
	
	// Include the main include file for running all routine.
	include_once ( $CONF_INCLUDE_PATH.'/library.inc.php' );

	// Include the ADOdb Class
	include_once ( $CONF_INCLUDE_PATH.'/adodb/adodb.inc.php');


	// --------------------------------------------------------------------------------------- //
	// Class :: OESgroup                                                                       //
	// --------------------------------------------------------------------------------------- //
	// Description  : This class contain the method to access the database to get/edit/create, //
	//                the group for the administrator and normal user account.                 //
	// --------------------------------------------------------------------------------------- //
	// Variable     :   $debug=0;                   // Change to 1 to enable debug mode        //
	// (Public)         $loginID;                   // login id                                //
	//                  $loginPwd;                  // login password                          //
	//                  $admin_info;                // login success, return information       //
	//                  $error;                     // Error message                           //
	//                  $autoLog=1;                 // '1'=Auto save LOG data, 0=Off           //
	//                                                                                         //
	//                  $readArray=array();         // All simular record in admin table       //
	//                  $selectLimit=0;             // Selecting limit (only work for find())  //
	//                                              // -- 0 mean no selection limit            //
	//                  $recordNum;                 // Total number of the record are founded. //
	//                  $searchRegular='AND';       // Search regular accept ('AND','OR only)  //
	//                  $searchMode='LIKE';         // Search mode accept ('LIKE', '=' only)   //
	//                  $orderBy='id,adm_login_id'; // Order by which column                   //
	//                  $orderMode='DESC';          // DESC = Descending Order                 //
	//                                              // ASC  = Ascending Order                  //
	//                                                                                         //
	//                                                                                         //
	// (Private)        $_DB_TBL='adm_users';       // Default table for logging system        //
	//                  $_DB_TYPE;                  // database information                    //
	//                  $_DB_ADDR;                                                             //
	//                  $_DB_PORT;                                                             //
	//                  $_DB_NAME;                                                             //
	//                  $_DB_USER;                                                             //
	//                  $_DB_PWD;                                                              //
	//                  $_LAST_QUERY;               // The last query string                   //
	//                  $_LAST_RECORD=array();      // Temp. var store the last finded record  //
	//                  $_selectOffset=0;           // Offset (only work for find())           //
	// --------------------------------------------------------------------------------------- //
	// Method       :   Admin_Account( $ID='', $PWD='' );                                      //
	// (Public)         setAdmin( $ID, $PWD );                                                 //
	//                  error();                                                               //
	//                  getData();                                                             //
	//                  read( $admID );                                                        //
	//                  find( $parent, $admLoginID, $admName, $admDesc, $admEmail, $admGroup,  //
	//                        $createDateTime, $expireDateTime, $orderBy );                    //
	//                  newGroup( $group_name='', $group_describe='', $group_enable='' );      //
	//                  update( $GID='', $group_name='', $group_describe='', $group_enable='');//
	//                  delGroup( $GID='' );                                                   //
	// (Private)        _getRecord( $admID, $parent, $admLoginID, $admName, $admDesc,          //
	//                              $admEmail, $admGroup, $createDateTime, $expireDateTime,    //
	//                              $orderBy );                                                //
	//                  _Record( $mode=1, $GID='', $group_name='', $group_describe='',         //
	//                           $group_enable='N' );                                          //
	// --------------------------------------------------------------------------------------- //
	// Examples     : (Getting all group information)                                          //
	//                   $myGroup = new OESGroup;                                              //
	// --------------------------------------------------------------------------------------- //
	class OESgroup
	{
		// -- Variable declaration --
		var		$debug=0;					// Change to 1 to enable debug mode
		var		$error;						// Error message
		var		$autoLog=1;					// '1'=Auto save LOG data, 0=Off

		var		$readArray=array();			// All simular record in admin table
		var		$selectLimit=0;				// Selecting limit (only work for find())
		                                    // -- 0 mean no selection limit
		var		$recordNum;					// Total number of the record are founded.
		var		$searchRegular='AND';		// Search regular accept ('AND','OR only)
		var		$searchMode='LIKE';			// Search mode accept ('LIKE', '=' only)
		var     $orderBy='id';				// Order by which column
		var		$orderMode='DESC';			// DESC = Descending Order
											// ASC	= Ascending Order


		var		$_DB_TBL='oes_group';		// Default table for OES Group
		var		$_DB_TYPE;					// database information
		var		$_DB_ADDR;
		var		$_DB_PORT;
		var		$_DB_NAME;
		var		$_DB_USER;
		var		$_DB_PWD;
		var		$_LAST_QUERY;				// The last query string
		var		$_LAST_RECORD=array();		// The temp. var store the last finded record
		var		$_selectOffset=0;			// Offset (only work for find())
		

		// ===================================================================
		// == Constructor		OESgroup::OESgroup				            ==
		// ==																==
		// == Usage : $myGroup = new OESgroup();				            ==
		// ===================================================================
		function OESgroup()
		{
			GLOBAL
				$CONF_DATABASE_TYPE,
				$CONF_DATABASE_ADDR,
				$CONF_DATABASE_PORT,
				$CONF_DATABASE_DBNAME,
				$CONF_DATABASE_ID,
				$CONF_DATABASE_PWD;

			// get the database information from configuration file
			$this->_DB_TYPE = $CONF_DATABASE_TYPE;
			$this->_DB_ADDR = $CONF_DATABASE_ADDR;
			$this->_DB_PORT = $CONF_DATABASE_PORT;
			$this->_DB_NAME = $CONF_DATABASE_DBNAME;
			$this->_DB_USER = $CONF_DATABASE_ID;
			$this->_DB_PWD  = $CONF_DATABASE_PWD;

			// Display debug message
			if ( $this->debug )
			{
				echo 'Class -= OESgroup =- ....<br>';
				echo '_DB_TYPE = '.$this->_DB_TYPE."<br>\n";
				echo '_DB_ADDR = '.$this->_DB_ADDR."<br>\n";
				echo '_DB_PORT = '.$this->_DB_PORT."<br>\n";
				echo '_DB_NAME = '.$this->_DB_NAME."<br>\n";
				echo '_DB_USER = '.$this->_DB_USER."<br>\n";
				echo '_DB_PWD = '.$this->_DB_PWD."<br>\n";
				echo '_DB_TBL = '.$this->_DB_TBL."<br><br>\n";				
			}
		}
		// -- End of constructor --


		// ===================================================================
		// == Class function	OESgroup::error();  					    ==
		// ==																==
		// == Return error message.											==
		// == Usage : $error = $myGroup->error();	    					==
		// ===================================================================
		function error()
		{
			if ( $this->error )
				// Return the error message
				return $this->error;
			else
				return FALSE;

			// -- Error message --
			// WRONG_PASSWORD  : wrong password.
			// UNKNOW_ERROR    : can't connect to DB, unknow reason.
			// NONE_OF_OUTPUT  : nothing can be output
		}
		// -- End of class function :: error() --


		// ===================================================================
		// == Class function    OESgroup::read( $GID='' )                   ==
		// ==                                                               ==
		// == Get the unique OES group record from database.                ==
		// == Usage : $myGroup->read( $GID );                               ==
		// ===================================================================
		function read( $GID )
		{
			// Save the current offset number
			$_selectOffset = $this->_selectOffset;

			// Get the result
			@ $this->_getRecord( $GID );

			// Reset the offset number
			$this->_selectOffset = $_selectOffset;

			// return the result
			return $this->readArray;
		}
		// -- End of class function :: read(..) --

		
		// ===================================================================
		// == Class function    OESgroup::find( $group_enable, $group_name, ==
		// ==                                   $group_describe, $orderBy ) ==
		// ==                                                               ==
		// == Get all the simular record from the database.                 ==
		// == Usage : $myGroup->find( $logCode, $logDateTime, $logUserID ); ==
		// ===================================================================
		function find( $group_enable='',$group_name='',$group_describe='',$orderBy='' )
		{
			if ( $orderBy )
				$this->orderBy = $orderBy;

			@ $this->_getRecord( '', $group_enable, $group_name, $group_describe, $orderBy );
			return $this->readArray;
		}


		// ===================================================================
		// == Class function	OESgroup::newGroup();  					    ==
		// ==																==
		// == Create a new group for OES. Return the record id when         ==
		// == successful created, return FALSE when fail.                   ==
		// == Usage : $result = $myGroup->newGroup( $group_name,            ==
		// ==                   $group_describe, $group_enable );           ==
		// ===================================================================
		function newGroup( $group_name='', $group_describe='', $group_enable='' )
		{
			// Exit this private class function and return FALSE,
			// when either the 'GroupName' or 'GroupDescribe' is empty.
			if ( $group_name=='' || $group_describe=='' )
			{
				// Check connection
				$this->error = "NO_RECORD_ADDED";

				if ( $this->debug )
				{
					// In Debug Mode
					echo $this->error."<br>\n";
					echo '$group_name = '.$group_name."<br>\n";
					echo '$group_describe = '.$group_describe."<br>\n";
					echo '$group_enable = '.$group_enable."<br>\n";
				}

				// Return FALSE
				return FALSE;
			}


			// $mode = 1     ->   Update record
			// $mode = 2     ->   Add a new record
			// $mode = 3     ->   Remove record
			@$result = $this->_Record( 2, '', $group_name, $group_describe, $group_enable );

			if ( $this->debug )
			{
				// In Debug Mode
				echo 'Inseart new record : '.$result." (0=Fail, other is success) <br>\n";
			}

			return $result;
		}


		// ===================================================================
		// == Class function	                                            ==
		// == OESgroup::update( $GID, $group_name, $group_describe,         ==
		// ==                   $group_enable );                            ==
		// ==																==
		// == Update a exist record. The result only be TRUE or FALSE.      ==
		// == Usage : $result = $myGroup->update( $GID, $group_name,        ==
		// ==                   $group_describe, $group_enable );           ==
		// ===================================================================
		function update( $GID='', $group_name='', $group_describe='', $group_enable='' )
		{
			if ( $GID=='' || !is_numeric($GID) || ($GID<0) || $group_name=='' )
			{
				if ( $this->debug )
					// In Debug Mode
					echo "Update Fail : Invalid Group ID!! <br>\n";

				// Invalid Group ID
				$this->error = 'CANNOT_UPDATE';

				return FALSE;
			}
			else
			{
			// $mode = 1     ->   Update record
			// $mode = 2     ->   Add a new record
			// $mode = 3     ->   Remove record
				@$result = $this->_Record( 1, $GID, $group_name, $group_describe, $group_enable );

				if ( $this->debug )
					// In Debug Mode
					echo 'Update record : '.$result." (0=Fail, 1=success) <br>\n";

				return $result;
			}
		}


		// ===================================================================
		// == Class function	                                            ==
		// == OESgroup::delGroup( $GID='' );                                ==
		// ==																==
		// == Delete a row of record from a group, return TRUE when success.==
		// ==																==
		// == Usage : $result = $myGroup->delGroup( $GID );                 ==
		// ===================================================================
		function delGroup( $GID='' )
		{
			if ( $GID=='' || !is_numeric($GID) || ($GID<0) )
			{
				if ( $this->debug )
					// In Debug Mode
					echo "Delete Fail : Invalid Group ID!! <br>\n";

				// Invalid Group ID
				$this->error = 'CANNOT_DELETE';

				return FALSE;
			}
			else
			{
				// $mode = 1     ->   Update record
				// $mode = 2     ->   Add a new record
				// $mode = 3     ->   Remove record
				@$result = $this->_Record( 3, $GID );

				if ( $this->debug )
					// In Debug Mode
					echo "Delete record id=$GID : ".$result." (0=Fail, 1=success) <br>\n";

				return $result;
			}
		}

		// ===================================================================
		// == Class private function                                        ==
		// == OESgroup::_getRecord( $recID, $group_enable, $group_name,     ==
		// ==             $group_describe, $orderBy )                       ==
		// ==                                                               ==
		// == Private function to find all the simular record from the      ==
		// == database of OES Group.                                        ==
		// ==                                                               ==
		// == Usage : $myGroup->_getRecord( $recID, $group_enable,          ==
		// ==                               $group_name, $group_describe,   ==
		// ==                               $orderBy );                     ==
		// ==                                                               ==
		// == HITS  : $recID=''   select all simular result.                ==
		// ==         $recID='??' select only 1 record from database.       ==
		// ===================================================================
		function _getRecord( $recID='', $group_enable='', $group_name='', 
			                 $group_describe='', $orderBy='' )
		{
			$db = ADONewConnection(db2adodb($this->_DB_TYPE));
			$db->debug = false;
			if ( chkDBIsODBC($this->_DB_TYPE) )
			{
				// The server type is ODBC, remove PORT setting
				// ...................
				// ..................
			}
			else
			{
				// Check the sql server with different port
				if ( $this->_DB_PORT )
					$sqlServer = $this->_DB_ADDR.":".$this->_DB_PORT;
				else
					$sqlServer = $this->_DB_ADDR;
			}

			// If user provide the database name, auto change to that database.
			if ( $this->_DB_NAME )
				$db->database = $this->_DB_NAME;

			if ( $this->debug )
			{
				// In Debug Mode
				echo "<hr>\n";
				echo 'SQL Server = '.$sqlServer;
			}

			// Create Connection
			@ $conn = $db->PConnect($sqlServer, $this->_DB_USER, $this->_DB_PWD);

			if ( !$conn )
			{
				// -- Connection Error --
				// If the $db->ErrorMsg() store some error message
				if ( $db->ErrorMsg() )
					$this->error =  $db->ErrorMsg();
				else
					// Check connection
					$this->error = "UNKNOW_ERROR";

				if ( $this->debug )
				{
					// In Debug Mode
					echo $this->error."<br>\n";
				}

				return FALSE;
			}
			else
			{
				if ( $this->debug )
				{
					// In Debug Mode
					echo "Connect Sucess!!<br>\n";
				}
				
				// Change the fetch mode
				$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
				
				// Check the current magic_quotes setting
				if ( get_magic_quotes_gpc() )
				{
					// Addslashes to prevent the special character input
					// (e.g. Chinese Input '\\\'...etc)
					$group_name		= addslashes ( $group_name );
					$group_describe	= addslashes ( $group_describe );
				}
				else
				{
					// Addslashed Twise times
					$group_name		= addslashes ( $group_name );
					$group_name		= addslashes ( $group_name );
					$group_describe	= addslashes ( $group_describe );
					$group_describe	= addslashes ( $group_describe );
				}

				if ( $recID=='' )
				{
					// -- Perpare the SQL query string --
					// Select all simular result
					$query = "SELECT * FROM ".$this->_DB_TBL;
					$tail  = '';

					// If search mode is 'LIKE' then the tring to be search must
					// be wrap by '%'
					if ( strtoupper($this->searchMode) == 'LIKE' )
						$percent = '%';
					else
						$percent = '';


					// --- Check the parameter entered, to complete the tail of query ---
					if ( $group_enable!='' and $tail!='' )
						$tail .= ' '.$this->searchRegular. " group_enable ".$this->searchMode." '$percent".$group_enable."$percent'";
					elseif ( $group_enable )
							$tail = "parent ".$this->searchMode." '$percent".$group_enable."$percent'";

					if ( $group_name!='' and $tail!='' )
						$tail .= ' '.$this->searchRegular. " group_name ".$this->searchMode." '$percent".$group_name."$percent'";
					elseif ( $group_name )
						$tail = "group_name ".$this->searchMode." '$percent".$group_name."$percent'";

					if ( $group_describe!='' and $tail!='' )
						$tail .= ' '.$this->searchRegular. " group_describe ".$this->searchMode." '$percent".$group_describe."$percent'";
					elseif ( $group_describe )
						$tail = "group_describe ".$this->searchMode." '$percent".$group_describe."$percent'";
					// --- End of tail of query checking ---


					// If any parameter entered, include the tail part.
					if ( $tail )
						$query .= " WHERE ( $tail ) ";
				}
				else
				{
					// -- Perpare the SQL query string --
					// Select only 1 record by the $recID
					$query = "SELECT * FROM ".$this->_DB_TBL." WHERE id='".$recID."'";
				}

				// Order by is set, generate the order by query string
				// (*** Hits: The order by is a list of the table column name ***)
				// (e.g orderBy='id,group_name,group_describe......';)
				if ( $orderBy!='' )
				{
					$orderArray = explode( ',', $orderBy );
					$orderBy    = '';
					for ( $i=0; $i<count($orderArray); $i++ )
					{
						$orderBy .= ' '.$orderArray[$i].' '.$this->orderMode;
						if ( ($i+1)<count($orderArray) )
							$orderBy .= ',';
					}
				}
				else
					// Use the default order by setting
					$orderBy = $this->orderBy;

				// Append the order by into the sql query string
				$query .= ' ORDER BY '.$orderBy;


				if ( $this->debug )
				{
					// In Debug Mode
					echo 'Query = '.$query."<br>\n";
				}

				// Store the query string into $_LAST_QUERY
				$this->_LAST_QUERY = $query;

				// Clear the array
				$this->readArray = array();

				// Check using SelectLimit or Execute mode
				if ( $this->selectLimit )
				{
					// Checking the selection is the same as before, 
					// if any of the selection condition is changed, 
					// reset the offset pointer.
					if ( $this->_LAST_RECORD['group_enable'] != $group_enable ||
						 $this->_LAST_RECORD['group_name'] != $group_name ||
						 $this->_LAST_RECORD['group_describe'] != $group_describe )
					{
						// reset the $_selectOffset
						$this->_selectOffset = 0;
						$this->_LAST_RECORD['group_enable'] = $group_enable;
						$this->_LAST_RECORD['group_name'] = $group_name;
						$this->_LAST_RECORD['group_describe'] = $group_describe;
					}

					// SelectLimit
					@ $rs = $db->SelectLimit( $query, $this->selectLimit, 
						                      $this->_selectOffset );

					// Change the offset pointer
					$this->_selectOffset += $this->selectLimit;
				}
				else
				{
					// reset the $_selectOffset
					$this->_selectOffset = 0;

					// execute the query
					@ $rs = $db->Execute($query);
				}


				if ( !$rs )
				{
					// Error on select from table
					$this->error = $db->ErrorMsg();

					if ( $this->debug )
					{
						// In Debug Mode
						echo 'Error = '.$this->error."<br>\n";
					}

					return FALSE;						
				}
				else
				{
					// Get total number of record founded
					// *** REMEMBER!! This will not be affected by select limit ***
					@ $rs_temp = $db->Execute($query);
					$this->recordNum = $rs_temp->PO_RecordCount();

					// check the number of result
					$numrows = 0;
					$numrows = $rs->PO_RecordCount($this->_DB_TBL);
					
					if ( !$numrows )
					{
						// Can't fount any simular log event from database
						$this->error = "NO_RECORD";
					}
					else
					{
						for ( $i=0; $i<$numrows; $i++ )
						{
							// Successful retrival the data
							$this->readArray[$i] = $rs->fields;

							$rs->MoveNext();
						}
					}

					// Display debug message
					if ( $this->debug )
					{
						echo 'Total number of record = '.intval($this->recordNum)."<br>\n";
						if ( $this->selectLimit )
							echo 'Select Limit = '.$this->selectLimit."<br>\n";
						echo 'Fetch array = ';
						
						if ( ( $this->recordNum > 1 ) && 
							 (($this->_selectOffset - $this->selectLimit) < intval($this->recordNum) ) )
						{
							echo ($this->_selectOffset - $this->selectLimit).' to ';
							if ( ( $this->selectLimit ) &&
								 (($this->_selectOffset - 1) <= intval($this->recordNum) ) )
								echo ($this->_selectOffset - 1)."<br>\n";
							else
								echo $this->recordNum."<br>\n";
						}
						else
							echo "0<br>\n";

							echo '$this->_selectOffset = '.$this->_selectOffset ."<br>\n";
							echo '$this->selectLimit = '.$this->selectLimit."<br>\n";

						for ( $i=0; $i<count($this->readArray); $i++ )
						{
							$fetchArray = $this->readArray[$i];
							$fetchArrayFlip = array_keys($fetchArray);

							foreach ( $fetchArrayFlip as $arrayName )
							{
								$sess_var_name  = 'TEMP_'.strtoupper( $arrayName );
								$$sess_var_name = noDoubleSpace( $fetchArray[$arrayName] );

								// Do Addslashed and Stripslashed to privent some special
								// charicator output from database but display wrongly.
								$$sess_var_name	= addslashes ( $$sess_var_name );
								$$sess_var_name	= stripslashes ( $$sess_var_name );
							}
							$count = $this->_selectOffset - $this->selectLimit + $i;

							echo "<br>\n";
							echo 'array['.($count)."]['id'] = ".
								 $TEMP_ID.' : ('.strlen($TEMP_ID).')'."<br>\n";
							echo 'array['.($count)."]['group_enable'] = ".
								 $TEMP_GROUP_ENABLE.' : ('.strlen($TEMP_GROUP_ENABLE).')'."<br>\n";
							echo 'array['.($count)."]['group_name'] = ".
								 $TEMP_GROUP_NAME.' : ('.strlen($TEMP_GROUP_NAME).')'."<br>\n";
							echo 'array['.($count)."]['group_describe'] = ".
								 $TEMP_GROUP_DESCRIBE.' : ('.strlen($TEMP_GROUP_DESCRIBE).')'."<br>\n";
						}
						echo "<hr>\n";
					}


					if ( !$numrows )
						return FALSE;
					else
						return TRUE;				
				}
			}
		}
		// -- End of private function :: _getRecord(..) --

	
	
		// ===================================================================
		// == Class private function                                        ==
		// == OESgroup::_Record ( $recID, $group_enable, $group_name,       ==
		// ==                     $group_describe, $orderBy )               ==
		// ==                                                               ==
		// == Private function to create/update/remove the record from the  ==
		// == database of OES Group.                                        ==
		// ==                                                               ==
		// == Usage : $myGroup->_Record( 0, 'id', 'g_name', 'g_des', 'Y' ); ==
		// ==                                                               ==
		// ===================================================================
		function _Record( $mode=1, $GID='', $group_name='', $group_describe='', $group_enable='N' )
		{
			// $mode = 1     ->   Update record
			// $mode = 2     ->   Add a new record
			// $mode = 3     ->   Remove record

			if ( $this->debug )
			{
				// In Debug Mode
				echo '$mode = '.$mode."<br>\n";
				echo '$GID = '.$GID."<br>\n";
				echo '$group_name = '.$group_name."<br>\n";
				echo '$group_describe = '.$group_describe."<br>\n";
				echo '$group_enable = '.$group_enable."<br>\n";
			}

			$db = ADONewConnection(db2adodb($this->_DB_TYPE));
			$db->debug = false;
			if ( chkDBIsODBC($this->_DB_TYPE) )
			{
				// The server type is ODBC, remove PORT setting
				// ...................
				// ..................
			}
			else
			{
				// Check the sql server with different port
				if ( $this->_DB_PORT )
					$sqlServer = $this->_DB_ADDR.":".$this->_DB_PORT;
				else
					$sqlServer = $this->_DB_ADDR;
			}


			// If user provide the database name, auto change to that database.
			if ( $this->_DB_NAME )
				$db->database = $this->_DB_NAME;

			if ( $this->debug )
			{
				// In Debug Mode
				echo '<hr>';
				echo 'Database   = '.$this->_DB_NAME."<br>\n";
				echo 'SQL Server = '.$sqlServer;
			}


			// Create Connection
			@ $conn = $db->PConnect($sqlServer, $this->_DB_USER, $this->_DB_PWD);

			if ( !$conn )
			{
				// -- Connection Error --
				// If the $db->ErrorMsg() store some error message
				if ( $db->ErrorMsg() )
					$this->error =  $db->ErrorMsg();
				else
					// Check connection
					$this->error = "UNKNOW_ERROR";

				if ( $this->debug )
					// In Debug Mode
					echo $this->error."<br>\n";

				return FALSE;
			}
			else
			{
				if ( $this->debug )
				{
					// In Debug Mode
					echo "Connect Sucess!!<br>\n";
					echo 'get_magic_quotes_gpc() = '.get_magic_quotes_gpc()."<br>\n";
					echo 'get_magic_quotes_runtime() = '.get_magic_quotes_runtime()."<br>\n";
				}
				
				// The group_enable is only allow 'Y' or 'N'
				$group_enable = strtoupper($group_enable);
				if ( $group_enable != 'Y' )
					$group_enable = 'N';

				// Check the current magic_quotes setting
				if ( get_magic_quotes_gpc()==0 )
				{
					// Addslashes to prevent the special character input
					// (e.g. Chinese Input '\\\'...etc)
					$group_name		= addslashes ( $group_name );
					$group_describe	= addslashes ( $group_describe );
				}

				// -- Perpare the SQL query string --
				if ( $mode == 1 )
				{
					// Update a record (i.e. update a existed GROUP)
					$query = "UPDATE ".$this->_DB_TBL." SET ".
							"group_enable='$group_enable', group_name='$group_name', group_describe='$group_describe' ".
							"WHERE id='$GID'";
				}
				elseif ( $mode == 2 )
				{
					// Add a new record (i.e. create a new GROUP)
					$nextID = $db->GenID($this->_DB_TBL.'_id_seq');
					$query = "INSERT INTO ".$this->_DB_TBL." VALUES ('$nextID', '$group_enable', '$group_name', '$group_describe')";
				}
				elseif ( $mode == 3 )
				{
					// Remove a record (i.e. remove a GROUP)
					$query = "DELETE FROM ".$this->_DB_TBL." WHERE id='$GID'";
				}

				if ( $this->debug )
					// In Debug Mode
					echo 'Query = '.$query."<br>\n";

				// Store the query string into $_LAST_QUERY
				$this->_LAST_QUERY = $query;


				// execute the query
				if ( @!$db->Execute($query) )
				{
					// Can't inseart a new group
					// If the $db->ErrorMsg() store some error message
					if ( $db->ErrorMsg() )
						$this->error =  $db->ErrorMsg();
					else
					{
						if ( $mode == 1 )
							// Can't update
							$this->error = "CANNOT_UPDATE";
						elseif ( $mode == 2 )
							// Can't inseart
							$this->error = "CANNOT_INSERT";
						elseif ( $mode == 3 )
							// Can't delete
							$this->error = "CANNOT_DELETE";
					}

					if ( $this->debug )
						// In Debug Mode
						echo 'Error = '.$this->error."<br><hr>\n";

					return FALSE;						
				}
				else
				{
					if ( $mode == 2 )
						// Inseart a new group SUCCESS!!
						// return the new group id
						return $nextID;
					elseif ( $mode == 1 || $mode == 3 )
						return TRUE;
				}

			}
		}
		// -- End of private function :: _Record(..) --
	
	}
	// -- End of class :: OESgroup --
?>