<?php
	// File        : /include/lib-mime.inc.php
	//
	// Description : This is file define all the MIME type.

	
	
	// MIME type use for Content-Type header 
	$mimetypes = array(
		'ez'		=> 'application/andrew-inset',
		'hqx'		=> 'application/mac-binhex40',
		'cpt'		=> 'application/mac-compactpro',
		'doc'		=> 'application/msword',
		'bin'		=> 'application/octet-stream',
		'dms'		=> 'application/octet-stream',
		'lha'		=> 'application/octet-stream',
		'lzh'		=> 'application/octet-stream',
		'exe'		=> 'application/octet-stream',
		'class'		=> 'application/octet-stream',
		'so'		=> 'application/octet-stream',
		'dll'		=> 'application/octet-stream',
		'oda'		=> 'application/oda',
		'pdf'		=> 'application/pdf',
		'ai'		=> 'application/postscript',
		'eps'		=> 'application/postscript',
		'ps'		=> 'application/postscript',
		'smi'		=> 'application/smil',
		'smil'		=> 'application/smil',
		'mif'		=> 'application/vnd.mif',
		'xls'		=> 'application/vnd.ms-excel',
		'ppt'		=> 'application/vnd.ms-powerpoint',
		'wbxml'		=> 'application/vnd.wap.wbxml',
		'wmlc'		=> 'application/vnd.wap.wmlc',
		'wmlsc'		=> 'application/vnd.wap.wmlscriptc',
		'bcpio'		=> 'application/x-bcpio',
		'vcd'		=> 'application/x-cdlink',
		'pgn'		=> 'application/x-chess-pgn',
		'cpio'		=> 'application/x-cpio',
		'csh'		=> 'application/x-csh',
		'dcr'		=> 'application/x-director',
		'dir'		=> 'application/x-director',
		'dxr'		=> 'application/x-director',
		'dvi'		=> 'application/x-dvi',
		'spl'		=> 'application/x-futuresplash',
		'gtar'		=> 'application/x-gtar',
		'hdf'		=> 'application/x-hdf',
		'js'		=> 'application/x-javascript',
		'skp'		=> 'application/x-koan',
		'skd'		=> 'application/x-koan',
		'skt'		=> 'application/x-koan',
		'skm'		=> 'application/x-koan',
		'latex'		=> 'application/x-latex',
		'nc'		=> 'application/x-netcdf',
		'cdf'		=> 'application/x-netcdf',
		'sh'		=> 'application/x-sh',
		'shar'		=> 'application/x-shar',
		'swf'		=> 'application/x-shockwave-flash',
		'sit'		=> 'application/x-stuffit',
		'sv4cpio'	=> 'application/x-sv4cpio',
		'sv4crc'	=> 'application/x-sv4crc',
		'tar'		=> 'application/x-tar',
		'tcl'		=> 'application/x-tcl',
		'tex'		=> 'application/x-tex',
		'texinfo'	=> 'application/x-texinfo',
		'texi'		=> 'application/x-texinfo',
		't'			=> 'application/x-troff',
		'tr'		=> 'application/x-troff',
		'roff'		=> 'application/x-troff',
		'man'		=> 'application/x-troff-man',
		'me'		=> 'application/x-troff-me',
		'ms'		=> 'application/x-troff-ms',
		'ustar'		=> 'application/x-ustar',
		'src'		=> 'application/x-wais-source',
		'xhtml'		=> 'application/xhtml+xml',
		'xht'		=> 'application/xhtml+xml',
		'zip'		=> 'application/zip',
		'au'		=> 'audio/basic',
		'snd'		=> 'audio/basic',
		'mid'		=> 'audio/midi',
		'midi'		=> 'audio/midi',
		'kar'		=> 'audio/midi',
		'mpga'		=> 'audio/mpeg',
		'mp2'		=> 'audio/mpeg',
		'mp3'		=> 'audio/mpeg',
		'aif'		=> 'audio/x-aiff',
		'aiff'		=> 'audio/x-aiff',
		'aifc'		=> 'audio/x-aiff',
		'm3u'		=> 'audio/x-mpegurl',
		'ram'		=> 'audio/x-pn-realaudio',
		'rm'		=> 'audio/x-pn-realaudio',
		'rpm'		=> 'audio/x-pn-realaudio-plugin',
		'ra'		=> 'audio/x-realaudio',
		'wav'		=> 'audio/x-wav',
		'pdb'		=> 'chemical/x-pdb',
		'xyz'		=> 'chemical/x-xyz',
		'bmp'		=> 'image/bmp',
		'gif'		=> 'image/gif',
		'ief'		=> 'image/ief',
		'jpeg'		=> 'image/jpeg',
		'jpg'		=> 'image/jpeg',
		'jpe'		=> 'image/jpeg',
		'png'		=> 'image/png',
		'tiff'		=> 'image/tiff',
		'tif'		=> 'image/tiff',
		'djvu'		=> 'image/vnd.djvu',
		'djv'		=> 'image/vnd.djvu',
		'wbmp'		=> 'image/vnd.wap.wbmp',
		'ras'		=> 'image/x-cmu-raster',
		'pnm'		=> 'image/x-portable-anymap',
		'pbm'		=> 'image/x-portable-bitmap',
		'pgm'		=> 'image/x-portable-graymap',
		'ppm'		=> 'image/x-portable-pixmap',
		'rgb'		=> 'image/x-rgb',
		'xbm'		=> 'image/x-xbitmap',
		'xpm'		=> 'image/x-xpixmap',
		'xwd'		=> 'image/x-xwindowdump',
		'igs'		=> 'model/iges',
		'iges'		=> 'model/iges',
		'msh'		=> 'model/mesh',
		'mesh'		=> 'model/mesh',
		'silo'		=> 'model/mesh',
		'wrl'		=> 'model/vrml',
		'vrml'		=> 'model/vrml',
		'css'		=> 'text/css',
		'html'		=> 'text/html',
		'htm'		=> 'text/html',
		'asc'		=> 'text/plain',
		'txt'		=> 'text/plain',
		'rtx'		=> 'text/richtext',
		'rtf'		=> 'text/rtf',
		'sgml'		=> 'text/sgml',
		'sgm'		=> 'text/sgml',
		'tsv'		=> 'text/tab-separated-values',
		'wml'		=> 'text/vnd.wap.wml',
		'wmls'		=> 'text/vnd.wap.wmlscript',
		'etx'		=> 'text/x-setext',
		'xsl'		=> 'text/xml',
		'xml'		=> 'text/xml',
		'mpeg'		=> 'video/mpeg',
		'mpg'		=> 'video/mpeg',
		'mpe'		=> 'video/mpeg',
		'qt'		=> 'video/quicktime',
		'mov'		=> 'video/quicktime',
		'mxu'		=> 'video/vnd.mpegurl',
		'avi'		=> 'video/x-msvideo',
		'movie'		=> 'video/x-sgi-movie',
		'ice'		=> 'x-conference/x-cooltalk',
	);



	// ###############################################################
	// # Function - getMIME( $inFileName );                          #
	// #                                                             #
	// # Enter the file name and return the MIME type.               #
	// ###############################################################
	function getMIME( $inFileName )
	{
		// get the file tail
		// e.g. myfile.txt ==> txt
		$filetype = substr(strrchr(basename($inFileName), '.'), 1);

		switch( $filetype )
		{
			case 'ez'		: $mime = 'application/andrew-inset'; break;
			case 'hqx'		: $mime = 'application/mac-binhex40'; break;
			case 'cpt'		: $mime = 'application/mac-compactpro'; break;
			case 'doc'		: $mime = 'application/msword'; break;
			case 'bin'		: $mime = 'application/octet-stream'; break;
			case 'dms'		: $mime = 'application/octet-stream'; break;
			case 'lha'		: $mime = 'application/octet-stream'; break;
			case 'lzh'		: $mime = 'application/octet-stream'; break;
			case 'exe'		: $mime = 'application/octet-stream'; break;
			case 'class'	: $mime = 'application/octet-stream'; break;
			case 'so'		: $mime = 'application/octet-stream'; break;
			case 'dll'		: $mime = 'application/octet-stream'; break;
			case 'oda'		: $mime = 'application/oda'; break;
			case 'pdf'		: $mime = 'application/pdf'; break;
			case 'ai'		: $mime = 'application/postscript'; break;
			case 'eps'		: $mime = 'application/postscript'; break;
			case 'ps'		: $mime = 'application/postscript'; break;
			case 'smi'		: $mime = 'application/smil'; break;
			case 'smil'		: $mime = 'application/smil'; break;
			case 'mif'		: $mime = 'application/vnd.mif'; break;
			case 'xls'		: $mime = 'application/vnd.ms-excel'; break;
			case 'ppt'		: $mime = 'application/vnd.ms-powerpoint'; break;
			case 'wbxml'	: $mime = 'application/vnd.wap.wbxml'; break;
			case 'wmlc'		: $mime = 'application/vnd.wap.wmlc'; break;
			case 'wmlsc'	: $mime = 'application/vnd.wap.wmlscriptc'; break;
			case 'bcpio'	: $mime = 'application/x-bcpio'; break;
			case 'vcd'		: $mime = 'application/x-cdlink'; break;
			case 'pgn'		: $mime = 'application/x-chess-pgn'; break;
			case 'cpio'		: $mime = 'application/x-cpio'; break;
			case 'csh'		: $mime = 'application/x-csh'; break;
			case 'dcr'		: $mime = 'application/x-director'; break;
			case 'dir'		: $mime = 'application/x-director'; break;
			case 'dxr'		: $mime = 'application/x-director'; break;
			case 'dvi'		: $mime = 'application/x-dvi'; break;
			case 'spl'		: $mime = 'application/x-futuresplash'; break;
			case 'gtar'		: $mime = 'application/x-gtar'; break;
			case 'hdf'		: $mime = 'application/x-hdf'; break;
			case 'js'		: $mime = 'application/x-javascript'; break;
			case 'skp'		: $mime = 'application/x-koan'; break;
			case 'skd'		: $mime = 'application/x-koan'; break;
			case 'skt'		: $mime = 'application/x-koan'; break;
			case 'skm'		: $mime = 'application/x-koan'; break;
			case 'latex'	: $mime = 'application/x-latex'; break;
			case 'nc'		: $mime = 'application/x-netcdf'; break;
			case 'cdf'		: $mime = 'application/x-netcdf'; break;
			case 'sh'		: $mime = 'application/x-sh'; break;
			case 'shar'		: $mime = 'application/x-shar'; break;
			case 'swf'		: $mime = 'application/x-shockwave-flash'; break;
			case 'sit'		: $mime = 'application/x-stuffit'; break;
			case 'sv4cpio'	: $mime = 'application/x-sv4cpio'; break;
			case 'sv4crc'	: $mime = 'application/x-sv4crc'; break;
			case 'tar'		: $mime = 'application/x-tar'; break;
			case 'tcl'		: $mime = 'application/x-tcl'; break;
			case 'tex'		: $mime = 'application/x-tex'; break;
			case 'texinfo'	: $mime = 'application/x-texinfo'; break;
			case 'texi'		: $mime = 'application/x-texinfo'; break;
			case 't'		: $mime = 'application/x-troff'; break;
			case 'tr'		: $mime = 'application/x-troff'; break;
			case 'roff'		: $mime = 'application/x-troff'; break;
			case 'man'		: $mime = 'application/x-troff-man'; break;
			case 'me'		: $mime = 'application/x-troff-me'; break;
			case 'ms'		: $mime = 'application/x-troff-ms'; break;
			case 'ustar'	: $mime = 'application/x-ustar'; break;
			case 'src'		: $mime = 'application/x-wais-source'; break;
			case 'xhtml'	: $mime = 'application/xhtml+xml'; break;
			case 'xht'		: $mime = 'application/xhtml+xml'; break;
			case 'zip'		: $mime = 'application/zip'; break;
			case 'au'		: $mime = 'audio/basic'; break;
			case 'snd'		: $mime = 'audio/basic'; break;
			case 'mid'		: $mime = 'audio/midi'; break;
			case 'midi'		: $mime = 'audio/midi'; break;
			case 'kar'		: $mime = 'audio/midi'; break;
			case 'mpga'		: $mime = 'audio/mpeg'; break;
			case 'mp2'		: $mime = 'audio/mpeg'; break;
			case 'mp3'		: $mime = 'audio/mpeg'; break;
			case 'aif'		: $mime = 'audio/x-aiff'; break;
			case 'aiff'		: $mime = 'audio/x-aiff'; break;
			case 'aifc'		: $mime = 'audio/x-aiff'; break;
			case 'm3u'		: $mime = 'audio/x-mpegurl'; break;
			case 'ram'		: $mime = 'audio/x-pn-realaudio'; break;
			case 'rm'		: $mime = 'audio/x-pn-realaudio'; break;
			case 'rpm'		: $mime = 'audio/x-pn-realaudio-plugin'; break;
			case 'ra'		: $mime = 'audio/x-realaudio'; break;
			case 'wav'		: $mime = 'audio/x-wav'; break;
			case 'pdb'		: $mime = 'chemical/x-pdb'; break;
			case 'xyz'		: $mime = 'chemical/x-xyz'; break;
			case 'bmp'		: $mime = 'image/bmp'; break;
			case 'gif'		: $mime = 'image/gif'; break;
			case 'ief'		: $mime = 'image/ief'; break;
			case 'jpeg'		: $mime = 'image/jpeg'; break;
			case 'jpg'		: $mime = 'image/jpeg'; break;
			case 'jpe'		: $mime = 'image/jpeg'; break;
			case 'png'		: $mime = 'image/png'; break;
			case 'tiff'		: $mime = 'image/tiff'; break;
			case 'tif'		: $mime = 'image/tiff'; break;
			case 'djvu'		: $mime = 'image/vnd.djvu'; break;
			case 'djv'		: $mime = 'image/vnd.djvu'; break;
			case 'wbmp'		: $mime = 'image/vnd.wap.wbmp'; break;
			case 'ras'		: $mime = 'image/x-cmu-raster'; break;
			case 'pnm'		: $mime = 'image/x-portable-anymap'; break;
			case 'pbm'		: $mime = 'image/x-portable-bitmap'; break;
			case 'pgm'		: $mime = 'image/x-portable-graymap'; break;
			case 'ppm'		: $mime = 'image/x-portable-pixmap'; break;
			case 'rgb'		: $mime = 'image/x-rgb'; break;
			case 'xbm'		: $mime = 'image/x-xbitmap'; break;
			case 'xpm'		: $mime = 'image/x-xpixmap'; break;
			case 'xwd'		: $mime = 'image/x-xwindowdump'; break;
			case 'igs'		: $mime = 'model/iges'; break;
			case 'iges'		: $mime = 'model/iges'; break;
			case 'msh'		: $mime = 'model/mesh'; break;
			case 'mesh'		: $mime = 'model/mesh'; break;
			case 'silo'		: $mime = 'model/mesh'; break;
			case 'wrl'		: $mime = 'model/vrml'; break;
			case 'vrml'		: $mime = 'model/vrml'; break;
			case 'css'		: $mime = 'text/css'; break;
			case 'html'		: $mime = 'text/html'; break;
			case 'htm'		: $mime = 'text/html'; break;
			case 'asc'		: $mime = 'text/plain'; break;
			case 'txt'		: $mime = 'text/plain'; break;
			case 'rtx'		: $mime = 'text/richtext'; break;
			case 'rtf'		: $mime = 'text/rtf'; break;
			case 'sgml'		: $mime = 'text/sgml'; break;
			case 'sgm'		: $mime = 'text/sgml'; break;
			case 'tsv'		: $mime = 'text/tab-separated-values'; break;
			case 'wml'		: $mime = 'text/vnd.wap.wml'; break;
			case 'wmls'		: $mime = 'text/vnd.wap.wmlscript'; break;
			case 'etx'		: $mime = 'text/x-setext'; break;
			case 'xsl'		: $mime = 'text/xml'; break;
			case 'xml'		: $mime = 'text/xml'; break;
			case 'mpeg'		: $mime = 'video/mpeg'; break;
			case 'mpg'		: $mime = 'video/mpeg'; break;
			case 'mpe'		: $mime = 'video/mpeg'; break;
			case 'qt'		: $mime = 'video/quicktime'; break;
			case 'mov'		: $mime = 'video/quicktime'; break;
			case 'mxu'		: $mime = 'video/vnd.mpegurl'; break;
			case 'avi'		: $mime = 'video/x-msvideo'; break;
			case 'movie'	: $mime = 'video/x-sgi-movie'; break;
			case 'ice'		: $mime = 'x-conference/x-cooltalk'; break;
			default			: $mime = 'application/octet-stream'; break;
		}

		return $mime;
	}

?>