<?php
	// File        : /include/library.inc.php
	//
	// Description : This is the general library for OES


	// --------------------------------------------------------------- //
	// Function - chk_browser();                                       //
	//                                                                 //
	// Detect the client browser, support CSS v1.0 or not              //
	// Return TRUE or FALSE                                            //
	//                                                                 //
	// *** Modifier this function if more browser support CSS v1.0     //
	// --------------------------------------------------------------- //
	function cssSupport()
	{
		detectBrowser('', $type, $version);

		settype($version, "integer");

		// Comment it when PHP < 4.2
		//		if ( (( strcmp(strtoupper($type),strtoupper('MSIE'))     == 0 ) && ( floatval($version) >= 5.5 )) ||
		//			 (( strcmp(strtoupper($type),strtoupper('Netscape')) == 0 ) && ( floatval($version) >= 6    )) )
		if ( (( strcmp(strtoupper($type),strtoupper('MSIE'))     == 0 ) && ( $version >= 5.5 )) ||
			 (( strcmp(strtoupper($type),strtoupper('Netscape')) == 0 ) && ( $version >= 6    )) )

			// The client browser is MSIE v5.5 or higher or Netscape v6.0 or higher
			// That mean client browser support CSS v1.0 or later
			return TRUE;
		else
			// The client browser may not support CSS v1.0
			return FALSE;

	}



	// --------------------------------------------------------------- //
	//  Function - crypt_str( $inStr , $outSize );                     //
	//                                                                 //
	//  Encrypt a string                                               //
	//    $inStr  = Input String to be encrypt                         //
	//    $outSize = Limit the encypted string size                    //
	// --------------------------------------------------------------- //
	function encryptString ( $inStr , $outSize = 0 )
	{
		// Define the private SEED
		$SEED[0] = "Xfgsje3sEHTYUsfHasdTH";
		$SEED[1] = "/3e'a/qw';32\5t43kder";
		$SEED[2] = "fv7453rRGregkuDqaq#@R";
		$SEED[3] = "%$FE$#&*$SAE#TDRHJ%^%";
		$SEED[4] = "G%$Ydxgrt45513eg5awer";
		$SEED[5] = "A$T$DFA_\rwqr~\23j%^#";

		// Size of input string
		$str_size = strlen ( $inStr );

		// Gen a crypt string for each char
		for ( $i=0,$y=0 ; $i<$str_size ; $i++ )
		{
			$md5_str[$i] = MD5 ( $inStr[$i] . $i . $SEED[$y++] . ($str_size - $i) );
			if ( $y >= count($SEED) )
				$y = 0;
		}
		

		// Reverse Order and merge the string array
		$num = 0;
		$i   = 0;
		$perCrypt_str = "";
		while ( $num < $str_size )
			$perCrypt_str = array_reverse ( array_merge ( $perCrypt_str , $md5_str[$num++]) );


		// Convert Char Array into a standard string form
		$big_str = "";
		for ( $i=0 ; $i<$str_size ; $i++ )
			$big_str = $big_str.$perCrypt_str[$i];


		// If the inSize is SET, limit the cryped string size
		// Otherwise the encypted string is very long
		if ( $outSize > 0 )
		{
			if ( $outSize < strlen ( $big_str ) )
				$crypt_str_size = $outSize;
			else
				$crypt_str_size = strlen ( $big_str );
			for ( $i=0 ; $i < $crypt_str_size ; $i++ )
				$crypt_str = $crypt_str.$big_str[$i];
		}
		else
			$crypt_str = $big_str;	

		
		// Return the encrypt password
		return $crypt_str;
	}



	// --------------------------------------------------------------- //
	// Function - detect_browser( $show = 1, &$type, &$ver );          //
	//                                                                 //
	// Detect the client browser type                                  //
	// return $type and $ver                                           //
	// --------------------------------------------------------------- //
	function detectBrowser( $show = 1, &$type, &$ver ) 
	{ 
		GLOBAL 
			$HTTP_USER_AGENT;         // Get Browser enveriment variables

		$HTTP_USER_AGENT = $_SERVER['HTTP_USER_AGENT'];

		// Browser 
		if(eregi("(opera)([0-9]{1,2}.[0-9]{1,3}){0,1}",$HTTP_USER_AGENT,$match) || eregi("(opera/)([0-9]{1,2}.[0-9]{1,3}){0,1}",$HTTP_USER_AGENT,$match)) 
		{	$BName = "Opera"; $BVersion=$match[2]; }
		elseif(eregi("(konqueror)/([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match)) 
		{	$BName = "Konqueror"; $BVersion=$match[2]; }
		elseif(eregi("(lynx)/([0-9]{1,2}.[0-9]{1,2}.[0-9]{1,2})",$HTTP_USER_AGENT,$match))
		{	$BName = "Lynx"; $BVersion=$match[2]; }
		elseif(eregi("(links)\(([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match)) 
		{	$BName = "Links"; $BVersion=$match[2]; }
		elseif(eregi("(msie) ([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match)) 
		{	$BName = "MSIE"; $BVersion=$match[2]; }
		elseif(eregi("(netscape6)/(6.[0-9]{1,3})",$HTTP_USER_AGENT,$match)) 
		{	$BName = "Netscape"; $BVersion=$match[2]; }
		elseif(eregi("(netscape)/([0-9].[0-9]{1,3})",$HTTP_USER_AGENT,$match)) 
		{	$BName = "Netscape"; $BVersion=$match[2]; }
		elseif(eregi("mozilla/5",$HTTP_USER_AGENT)) 
		{	$BName = "Netscape"; $BVersion="Unknown"; }
		elseif(eregi("(mozilla)/([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match))
		{	$BName = "Netscape"; $BVersion=$match[2]; }
		elseif(eregi("w3m",$HTTP_USER_AGENT)) 
		{	$BName = "w3m"; $BVersion="Unknown"; }
		else
		{$BName = "Unknown"; $BVersion="Unknown"; } 

		// System 
		if(eregi("linux",$HTTP_USER_AGENT)) 
			$BPlatform = "Linux"; 
		elseif(eregi("win32",$HTTP_USER_AGENT)) 
			$BPlatform = "Windows"; 
		elseif((eregi("(win)([0-9]{2})",$HTTP_USER_AGENT,$match)) || (eregi("(windows) ([0-9]{2})",$HTTP_USER_AGENT,$match))) 
			$BPlatform = "Windows $match[2]"; 
		elseif(eregi("(winnt)([0-9]{1,2}.[0-9]{1,2}){0,1}",$HTTP_USER_AGENT,$match)) 
			$BPlatform = "Windows NT $match[2]"; 
		elseif(eregi("(windows nt)(){0,1}([0-9]{1,2}.[0-9]{1,2}){0,1}",$HTTP_USER_AGENT,$match)) 
			$BPlatform = "Windows NT $match[3]"; 
		elseif(eregi("mac",$HTTP_USER_AGENT)) 
			$BPlatform = "Macintosh"; 
		elseif(eregi("(sunos)([0-9]{1,2}.[0-9]{1,2}){0,1}",$HTTP_USER_AGENT,$match)) 
			$BPlatform = "SunOS $match[2]"; 
		elseif(eregi("(beos)r([0-9]{1,2}.[0-9]{1,2}){0,1}",$HTTP_USER_AGENT,$match)) 
			$BPlatform = "BeOS $match[2]"; 
		elseif(eregi("freebsd",$HTTP_USER_AGENT)) 
			$BPlatform = "FreeBSD"; 
		elseif(eregi("openbsd",$HTTP_USER_AGENT)) 
			$BPlatform = "OpenBSD"; 
		elseif(eregi("irix",$HTTP_USER_AGENT)) 
			$BPlatform = "IRIX"; 
		elseif(eregi("os/2",$HTTP_USER_AGENT)) 
			$BPlatform = "OS/2"; 
		elseif(eregi("plan9",$HTTP_USER_AGENT)) 
			$BPlatform = "Plan9"; 
		elseif(eregi("unix",$HTTP_USER_AGENT) || eregi("hp-ux",$HTTP_USER_AGENT)) 
			$BPlatform = "Unix"; 
		elseif(eregi("osf",$HTTP_USER_AGENT)) 
			$BPlatform = "OSF"; 
		else{$BPlatform = "Unknown";} 

		$type = $BName;
		$ver  = $BVersion;
		
		if ( $show == 1 ) 
		{
			// Display Result
			echo $HTTP_USER_AGENT."<br>"; 
			echo $BName."<br>"; 
			echo $BVersion."<br>"; 
			echo $BPlatform."<br>"; 
		}
	} 



	// --------------------------------------------------------------- //
	// Function - arrayNoDuplicate ( $inArray );                       //
	//                                                                 //
	// Return a removed duplicate rows from an array                   //
	// --------------------------------------------------------------- //
	function arrayNoDuplicate ( $inArray )
	{
		if ( is_array($inArray) )
		{
			$outArray[0] = '';
			$num = 0;

			for ( $i=0; $i<count($inArray); $i++ )
			{
				$isDuplicate = FALSE;

				for ( $y=0; $y<count($outArray); $y++ )
				{
					if ( $inArray[$i] == $outArray[$y] )
					{
						$isDuplicate = True;
						break;
					}
				}

				// If no any duplicate terms
				if (!$isDuplicate)
					$outArray[$num++] = $inArray[$i];
			}

			// return the unique array (i.e. no duplicate terms)
			return $outArray;
		}
		else
			// the input is not an array, return FALSE
			return FALSE;
	}



	// --------------------------------------------------------------- //
	// Function - chkSQLName ( $inSQLType );                           //
	//                                                                 //
	// Return the sql server Name                                      //
	// --------------------------------------------------------------- //
	function chkSQLName ( $inSQLType )
	{
		switch ( strtolower($inSQLType) )
		{
			case 'mssql'	: $sqlName = 'Microsoft SQL Server'; break;
			case 'vfp'		: $sqlName = 'Microsoft Visual FoxPro'; break;
			case 'mysql'	: $sqlName = 'MySQL'; break;
			case 'odbc'		: $sqlName = 'ODBC'; break;
			case 'ora'		: $sqlName = 'Oracle'; break;
			case 'ora8'		: $sqlName = 'Oracle 8'; break;
			case 'pgsql'	: $sqlName = 'PostgreSQL'; break;
		}

		// Return the SQL server type Name
		return $sqlName;
	}



	// --------------------------------------------------------------- //
	// Function - chkDBIsODBC ( $inSQLType );                          //
	//                                                                 //
	// Return TRUE if the sql server is use ODBC connect               //
	// --------------------------------------------------------------- //
	function chkDBIsODBC ( $inSQLType )
	{
		switch ( strtolower($inSQLType) )
		{
			case 'vfp'		: 
			case 'odbc'		: return TRUE;
			default			: return FALSE;
		}
	}



	// --------------------------------------------------------------- //
	// Function - chkDBSupport ( $inSQLType );                         //
	//                                                                 //
	// Return TRUE if the database is support in current PHP           //
	// --------------------------------------------------------------- //
	function chkDBSupport ( $inSQLType )
	{
		switch ( strtolower($inSQLType) )
		{
			case 'mssql'	: $sqlType = 'mssql'; break;
			case 'vfp'		: $sqlType = 'vfp'; break;
			case 'mysql'	: $sqlType = 'mysql'; break;
			case 'odbc'		: $sqlType = 'odbc'; break;
			case 'ora'		: $sqlType = 'ora'; break;
			case 'ora8'		: $sqlType = 'ora8'; break;
			case 'pgsql'	: $sqlType = 'pgsql'; break;
		}

		// Check the database modules is loaded by PHP
		if ( extension_loaded($sqlType) )
			return TRUE;
		else
			return FALSE;
	}



	// --------------------------------------------------------------- //
	// Function - db2adodb ( $inSQLType );                             //
	//                                                                 //
	// Change the database type into ADOdb driver name.                //
	// --------------------------------------------------------------- //
	function db2adodb ( $inSQLType )
	{
		switch ( strtolower($inSQLType) )
		{
			case 'mssql'	: $sqlType = 'mssql'; break;
			case 'vfp'		: $sqlType = 'vfp'; break;
			case 'mysql'	: $sqlType = 'mysql'; break;
			case 'odbc'		: $sqlType = 'odbc'; break;
			case 'ora'		: $sqlType = 'oracle'; break;
			case 'ora8'		: $sqlType = 'oci8po'; break;
			case 'pgsql'	: $sqlType = 'postgres'; break;
		}

		return $sqlType;
	}



	// --------------------------------------------------------------- //
	// Function - find_net($host,$mask);                               //
	//                                                                 //
	// Function to determine network characteristics                   //
	// $host = IP address or hostname of target host (string)          //
	// $mask = Subnet mask of host in dotted decimal (string)          //
	// returns array with                                              //
	//   "cidr"      => host and mask in CIDR notation                 //
	//   "network"   => network address                                //
	//   "broadcast" => broadcast address                              //
	//                                                                 //
	// Example: find_net("192.168.37.215","255.255.255.224")           //
	// returns:                                                        //
	//    "cidr"      => 192.168.37.215/27                             //
	//    "network"   => 192.168.37.192                                //
	//    "broadcast" => 192.168.37.223                                //
	//                                                                 //
	// --------------------------------------------------------------- //
	function find_net($host,$mask) 
	{ 
		$bits          = strpos( decbin( ip2long( $mask ) ),"0" ); 
		$net["cidr"]   = gethostbyname( $host ).'/'.$bits; 
		$net["network"]= long2ip( bindec( decbin( ip2long( gethostbyname( $host ) ) ) & decbin( ip2long( $mask ) ) ) ); 
		$binhost       = str_pad( decbin( ip2long( gethostbyname( $host ) ) ),32,'0',STR_PAD_LEFT); 
		$binmask       = str_pad( decbin( ip2long( $mask ) ),32,'0',STR_PAD_LEFT); 

		for ( $i=0; $i<32; $i++ )
		{ 
			if ( substr( $binhost, $i, 1 ) == '1' || substr( $binmask, $i, 1 ) == '0' ) 
				$broadcast .= '1'; 
			else 
				$broadcast .= '0'; 
		} 

		$net["broadcast"] = long2ip( bindec( $broadcast ) ); 

		return $net; 
	}



	// --------------------------------------------------------------- //
	// Function - vaidEmail ( $inEmail );                              //
	//                                                                 //
	// Return TRUE if the input string is a vaid email string.         //
	// --------------------------------------------------------------- //
	function vaidEmail ( $inEmail )
	{
		$regularExpression = "^[a-zA-Z0-9]+([_\\.-][a-zA-Z0-9]+)*@([a-zA-Z0-9]+([\.-][a-zA-Z0-9]+)*)+\\.[a-zA-Z]{2,}$";
		return ( ereg( $regularExpression, $inEmail ) );
	}


	// --------------------------------------------------------------- //
	// Function - noDoubleSpace ( $inStr );                            //
	//                                                                 //
	// Remove the double space in a string. (mainly for PgSQL)         //
	// --------------------------------------------------------------- //
	function noDoubleSpace ( $inStr )
	{
		$noSpace = ereg_replace('  ', '', $inStr);

		// If the end char is a space, remove it
		if ( $noSpace[strlen($noSpace)-1] == ' ' )
			$noSpace = substr( $noSpace, 0, (strlen($noSpace)-1) );

		return $noSpace;
	}



	// --------------------------------------------------------------- //
	// Function - noComment ( $inPreg );                               //
	//                                                                 //
	// Remove the comment from input contents. The comment block       //
	// look like /*.....*/ or a single line comment //                 //
	//                                                                 //
	// Usage : $inPreg enter a block of string and return              //
	//         un-commented content                                    //
	// --------------------------------------------------------------- //
	function noComment ( $inPreg )
	{
		// << Phrase out comment block >>
		$expression  =  "!" . quotemeta("/*") . "(.*)" . quotemeta("*/") . "!Uise";
		$replacement = '';
		$outPreg     = preg_replace( $expression, $replacement, $inPreg );
		// << END of phrase out comment block >>


		// << Phrase out single line comment >>
		$ourLine = split ( "\n" , $outPreg );            // Split the TEXT to line array
		for ( $i=0 ; $i < count( $ourLine ) ; $i++ )     // Remove the comment on each line
		{
			$line = explode ( '//' , $ourLine[$i] );
			$ourLine[$i] = $line[0];
		}
		$outPreg = implode(	"\n" , $ourLine );           // Join the line array into one TEXT variable
		// << END of phrase out single line comment >>


		// Return no-comment content
		return $outPreg;
	}



	// --------------------------------------------------------------- //
	// Function - getFileVar ( $inStr );                               //
	//                                                                 //
	// Return an array of variables which found in the input TEXT      //
	// file.                                                           //
	// --------------------------------------------------------------- //
	function getFileVar ( $file )
	{
		$fs = @fopen ($file, "r");
		if (!$fs)
			return FALSE;
		else
		{
			// Open file success, read the file line by line.
			$i = 0;
			while (!feof ($fs))
			{
				$fileLine[$i] = fgets( $fs, filesize($file) );
				if ( $end = strpos( $fileLine[$i], ';' ) )
				{
					$fileLine[$i] = substr( $fileLine[$i], 0, $end );
					$fileLine[$i] = ereg_replace( ";", '', $fileLine[$i]);
					$fileLine[$i] = ereg_replace( "\n", '', $fileLine[$i]);
					$fileLine[$i] = ereg_replace( "\t", '', $fileLine[$i]);
					$fileLine[$i] = ereg_replace( "'", '', $fileLine[$i]);
					$fileLine[$i] = ereg_replace( '"', '', $fileLine[$i]);
					$i++;
				}
			}
			
			// remove tha last array element, which is not used.
			unset ($fileLine[count($fileLine)-1]);

			foreach ( $fileLine as $line )
			{
				$temp = explode( '=', $line );
				$varArray[$temp[0]] = $temp[1];
			}
		}
		
		return $varArray;

		fclose ($fs);
	}



	// --------------------------------------------------------------- //
	// Function - randomPasswd($size);                                 //
	//                                                                 //
	// Return a random number, the size can be limited.                //
	// --------------------------------------------------------------- //
	function getRandom ( $size = 0 ) 
	{ 
		// seed with microseconds
		mt_srand( _make_seed() );
		$result = mt_rand();
		if (( strlen($result) > $size ) && ( $size ) )
			$result = substr ( $result, 0 ,$size );
		return $result;
	}


	// --------------------------------------------------------------- //
	// Function - _make_seed($size);                                   //
	//                                                                 //
	// Private function, return the random seed for any function,      //
	// which require the seed.                                         //
	// --------------------------------------------------------------- //
	function _make_seed() 
	{
		list( $usec, $sec ) = explode( ' ', microtime() );
		return (float) $sec + ( (float) $usec * 100000 );
	}

?>