<?
	// File        : /include/setup/setup.php
	//
	// Description : Setup file, to generate the configuration file.
	
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// Please modifier this line if you want to change the default setup language
	// You can change this variable to 'EN' or 'BIG5'
	$DEFAULT_SETUP_LANGUAGE = 'en';

	$OES_INSTALL_PATH = '../..';
	///////////////////////////////////////////////////////////////////////////////////////////////////////	




// ******************************************************************************************** //
	// Define the maximun step for setup
	$MAX_STEP = 8;

	// Define the current OES version
	$PROGRAM_NAME				=	'Open Educational System';
	$PROGRAM_VER				=	'v0.1(beta)';

	// Default OES system Path
    define ("DEFAULT_setupSysConfigPath"    , '/conf'          ,TRUE);
    define ("DEFAULT_setupSysIncludePath"   , '/include'       ,TRUE);
    define ("DEFAULT_setupSysThemesPath"    , '/users/themes'  ,TRUE);
    define ("DEFAULT_setupSysModulesPath"   , '/users/modules'  ,TRUE);
    define ("DEFAULT_setupSysAdminPath"     , '/admin'         ,TRUE);
    define ("DEFAULT_setupSysAdminThemes"   , '/admin/themes'  ,TRUE);
    define ("DEFAULT_setupSysAdminModules"  , '/admin/modules' ,TRUE);
    define ("DEFAULT_setupSysSessionPath"   , '/session'       ,TRUE);
    define ("DEFAULT_setupSysSessionAdmPath", '/session/admin' ,TRUE);

	// Define the defailt configuration file
	define ("DEFAULT_configFile"            , 'config.inc.php' , TRUE);

	// The configuration file templet
	define ("DEFAULT_configFileTemplet"     , 'config.inc' , TRUE);
// ******************************************************************************************** //

	// Sleep for 1 second to brock DOS attack
	sleep(1);

	/////////////////////////////////////////////////////////////
	//                       Warning!!                         //
	//                                                         //
	// Don't modifier the following of this configuration file //
	//  unless you know what you are doing.                    //
	/////////////////////////////////////////////////////////////
	
	// Move all session file into a folder
	session_save_path ( $OES_INSTALL_PATH.'/session' );

	// Change the session name
	session_name ( 'SSID' );

	// Start session
	session_start();

	
	// Include the main include file
	include_once ($OES_INSTALL_PATH.'/include/library.inc.php');


	// If change the setup language, do this
	if ( isset($setupLang) && isset($buttonNext) )
	{
		// If the setup language is not stored in session, or the setup language was change,
		// do this
		if ( !session_is_registered("sess_setupLang") || ( $sess_setupLang != $setupLang ) )
		{
			$sess_setupLang = $setupLang;

			// Save the user defined language into session variable
			session_register("sess_setupLang");
		}
	}


	// Load the session variable if the language was change
	if ( session_is_registered("sess_setupLang") )
		$setupLang = $sess_setupLang;


	// Choose which language will be used for setup
	if ( isset($setupLang) || isset($lang) )
	{
		// ***   Check the charset is pressent   ***
		// *** and load the setup language file ***
		if ( isset($lang) )
			$setupLang = $lang;

		// Upcase the variable $lang
		$setupLang = strtolower ($setupLang);

		if ( file_exists($OES_INSTALL_PATH.'/include/setup/lang/'.$setupLang.'.lang.php') )
		{
			$default_charset = $setupLang;
			include ($OES_INSTALL_PATH.'/include/setup/lang/'.$setupLang.'.lang.php');
		}
		else
		{
			$default_charset = $DEFAULT_SETUP_LANGUAGE;
			include ($OES_INSTALL_PATH.'/include/setup/lang/'.$DEFAULT_SETUP_LANGUAGE.'.lang.php');
		}
	}
	else
	{
		$default_charset = $DEFAULT_SETUP_LANGUAGE;
		include ($OES_INSTALL_PATH.'/include/setup/lang/'.$DEFAULT_SETUP_LANGUAGE.'.lang.php');
	}


	// Check the $step and do allow rollback
	if ( $step < 0 || $step > ($MAX_STEP + 1) )
		Header ( 'Location: '.$SCRIPT_NAME );
	else
	{
		// Redirect to first page if the user type the STEP himself
		// (i.e. the step 9 only be show when press the NEXT button)
		if ( $step > $MAX_STEP && !isset($buttonNext) )
			Header ( 'Location: '.$SCRIPT_NAME );

		
		// Look the step size, do not over the maximum step
		if ( $step > ($MAX_STEP + 1) )
			$step = $MAX_STEP;


		if ( isset($buttonBack) )
			// do Roll-back
			if ( ($step - 2) > 0 )
			{
				$step = $step - 2;
				Header ( 'Location: '.$SCRIPT_NAME.'?step='.$step );
			}
			else
				Header ( 'Location: '.$SCRIPT_NAME );


		if ( isset($buttonNext) )
		{
			switch ( $step )
			{
				// Check the user input in step 4 (database name and account)
				// if have any error, lock the page.
				// (i.e. only page 5 can check page 4 input)
				case 5: // Check the database type is ODBC or not
						if ( chkDBIsODBC($sess_setupSQLType) )
						{
							// If ODBC, only check have type the datasource, user id and password
							// NOT Empty and no space
							if ( $setupSQLDomain == '' || 
//								 $setupSQLAccount == '' || 
//								 $setupSQLPassword == '' || 
								 ereg(' ',$setupSQLDomain) 
//									 || 
//								 ereg(' ',$setupSQLAccount) || 
//								 ereg(' ',$setupSQLPassword) 
								)
								// Set the doLockPage flag to lock the page
								$doLockPage = TRUE;
							else
								$doLockPage = FALSE;
						}
						else
						{
							// The database type is NOT ODBC

							// Not allow empty database server IP(or domain), and database account name and password,
							// If server port is not empty, check is Real Integer value
							// also not allow the input data with SPACE
							if	( 
//									$setupSQLDomain == '' || 
									$setupSQLDB == '' || 
									$setupSQLAccount == '' || 
									$setupSQLPassword == '' || 
									( $setupSQLPort!='' && 
										(
										 $setupSQLPort <= 0 || 
										 $setupSQLPort != intval($setupSQLPort) || 
										 ( !is_numeric($setupSQLPort) )
										)
									) || 
									strlen($setupSQLPort)>6 || 
									ereg(' ',$setupSQLDomain) || 
									ereg(' ',$setupSQLDB) || 
									ereg(' ',$setupSQLPort) || 
									ereg(' ',$setupSQLAccount) || 
									ereg(' ',$setupSQLPassword) 
								)
							{
								$doLockPage = True;
							}
						}


						// Check the doLockPage flag is set or not
						if ( $doLockPage )
						{
							// Set the error occure flag
							$sess_iserror = 4;
							session_register("sess_iserror");

							// Redirect to error occure page
							// (i.e. lock the page)
							header ('Location: '.$SCRIPT_NAME.'?step='.($sess_iserror));
						}
						else
						{
							// Remove session error flag
							session_unregister("sess_iserror");
						}

						break;



				// Check the user input in step 6 (System Environment)
				// if have any error, lock the page.
				// (i.e. only page 7 can check page 6 input)
				case 7: $doLockPage = FALSE;

						// Check the current magic_quotes setting
						if ( get_magic_quotes_gpc() )
						{
							// Un-quote string (by default, magic_quotes is ON)
							$setupSysInstallPath	= stripslashes ( $setupSysInstallPath );
							$setupSysConfigPath		= stripslashes ( $setupSysConfigPath );
							$setupSysIncludePath	= stripslashes ( $setupSysIncludePath );
							$setupSysThemesPath		= stripslashes ( $setupSysThemesPath );
							$setupSysModulesPath	= stripslashes ( $setupSysModulesPath );
							$setupSysSessionPath	= stripslashes ( $setupSysSessionPath );
							$setupSysAdminPath	    = stripslashes ( $setupSysAdminPath );
							$setupSysAdminThemes    = stripslashes ( $setupSysAdminThemes );
							$setupSysAdminModules   = stripslashes ( $setupSysAdminModules );
							$setupSysSessionAdmPath = stripslashes ( $setupSysSessionAdmPath );
							$setupSysURL			= stripslashes ( $setupSysURL );
							$setupSysAdminURL		= stripslashes ( $setupSysAdminURL );
						}
						else
						{
							// Addslashes to  string
							$setupSysInstallPath	= addslashes ( $setupSysInstallPath );
							$setupSysConfigPath		= addslashes ( $setupSysConfigPath );
							$setupSysIncludePath	= addslashes ( $setupSysIncludePath );
							$setupSysThemesPath		= addslashes ( $setupSysThemesPath );
							$setupSysModulesPath	= addslashes ( $setupSysModulesPath );
							$setupSysSessionPath	= addslashes ( $setupSysSessionPath );
							$setupSysAdminPath	    = addslashes ( $setupSysAdminPath );
							$setupSysAdminThemes    = addslashes ( $setupSysAdminThemes );
							$setupSysAdminModules   = addslashes ( $setupSysAdminModules );
							$setupSysSessionAdmPath = addslashes ( $setupSysSessionAdmPath );
							$setupSysURL			= addslashes ( $setupSysURL );
							$setupSysAdminURL		= addslashes ( $setupSysAdminURL );
						}


						// *** Start for check the input from page 6 ***
						if ( $setupSysInstallPath == '' ||
							 ereg(' ',$setupSysInstallPath) ||
							 !ereg('([0-9a-zA-Z])', $setupSysInstallPath[strlen($setupSysInstallPath) - 1] ) )
							$doLockPage = TRUE; 

						if ( $setupSysConfigPath == '' ||
							 ereg(' ',$setupSysConfigPath) ||
							 !ereg('([0-9a-zA-Z])', $setupSysConfigPath[strlen($setupSysConfigPath) - 1] ) )
							$doLockPage = TRUE; 

						if ( $setupSysIncludePath == '' ||
							 ereg(' ',$setupSysIncludePath) ||
							 !ereg('([0-9a-zA-Z])', $setupSysIncludePath[strlen($setupSysIncludePath) - 1] ) )
								$doLockPage = TRUE; 

						if ( $setupSysThemesPath == '' ||
							 ereg(' ',$setupSysThemesPath) ||
							 !ereg('([0-9a-zA-Z])', $setupSysThemesPath[strlen($setupSysThemesPath) - 1] ) )
								$doLockPage = TRUE; 

						if ( $setupSysModulesPath == '' ||
							 ereg(' ',$setupSysModulesPath) ||
							 !ereg('([0-9a-zA-Z])', $setupSysModulesPath[strlen($setupSysModulesPath) - 1] ) )
								$doLockPage = TRUE; 

						if ( $setupSysSessionPath == '' ||
							 ereg(' ',$setupSysSessionPath) ||
							 !ereg('([0-9a-zA-Z])', $setupSysSessionPath[strlen($setupSysSessionPath) - 1] ) )
								$doLockPage = TRUE; 

						if ( $setupSysAdminPath == '' ||
							 ereg(' ',$setupSysAdminPath) ||
							 !ereg('([0-9a-zA-Z])', $setupSysAdminPath[strlen($setupSysAdminPath) - 1] ) )
								$doLockPage = TRUE; 

						if ( $setupSysAdminThemes == '' ||
							 ereg(' ',$setupSysAdminThemes) ||
							 !ereg('([0-9a-zA-Z])', $setupSysAdminThemes[strlen($setupSysAdminThemes) - 1] ) )
								$doLockPage = TRUE; 

						if ( $setupSysAdminModules == '' ||
							 ereg(' ',$setupSysAdminModules) ||
							 !ereg('([0-9a-zA-Z])', $setupSysAdminModules[strlen($setupSysAdminModules) - 1] ) )
								$doLockPage = TRUE; 


						if ( $setupSysSessionAdmPath == '' ||
							 ereg(' ',$setupSysSessionAdmPath) ||
							 !ereg('([0-9a-zA-Z])', $setupSysSessionAdmPath[strlen($setupSysSessionAdmPath) - 1] ) )
								$doLockPage = TRUE; 

						if ( $setupSysURL == '' ||
							 ereg(' ',$setupSysURL) ||
							 !ereg('([0-9a-zA-Z])', $setupSysURL[strlen($setupSysURL) - 1] ) )
								$doLockPage = TRUE; 

						if ( $setupSysAdminURL == '' ||
							 ereg(' ',$setupSysAdminURL) ||
							 !ereg('([0-9a-zA-Z])', $setupSysAdminURL[strlen($setupSysAdminURL) - 1] ) )
								$doLockPage = TRUE; 
						// *** End of check the input from page 6 ***


						// Check the doLockPage flag is set or not
						if ( $doLockPage )
						{
							// Set the error occure flag
							$sess_iserror = 6;
							session_register("sess_iserror");

							// Redirect to error occure page
							// (i.e. lock the page)
							header ('Location: '.$SCRIPT_NAME.'?step='.($sess_iserror));
						}
						else
						{
							// Remove session error flag
							session_unregister("sess_iserror");
						}

						break;

			
			
				// Check the user input in step 7 (Administrator Account)
				// if have any error, lock the page.
				// (i.e. only page 8 can check page 7 input)
				case 8: $doLockPage = FALSE;

						// Check the current magic_quotes setting
						if ( get_magic_quotes_gpc() )
						{
							// Un-quote string (by default, magic_quotes is ON)
							$setupAdmID			= stripslashes ( $setupAdmID );
							$setupAdmPwd		= stripslashes ( $setupAdmPwd );
							$setupAdmPwdAgain	= stripslashes ( $setupAdmPwdAgain );
							$setupAdmEmail		= stripslashes ( $setupAdmEmail );
						}
						else
						{
							// Addslashes to  string
							$setupAdmID			= addslashes ( $setupAdmID );
							$setupAdmPwd		= addslashes ( $setupAdmPwd );
							$setupAdmPwdAgain	= addslashes ( $setupAdmPwdAgain );
							$setupAdmEmail		= addslashes ( $setupAdmEmail );
						}


						// *** Start for check the input from page 7 ***
						if	( 
								$setupAdmID == '' || 
								$setupAdmPwd == '' || 
								$setupAdmPwdAgain == '' || 
								$setupAdmEmail == '' || 
								ereg(' ',$setupAdmID) || 
								ereg(' ',$setupAdmPwd) || 
								ereg(' ',$setupAdmPwdAgain) || 
								ereg(' ',$setupAdmEmail) ||
								$setupAdmPwd != $setupAdmPwdAgain ||
								( isset($setupAdmEmail) && !vaidEmail ( $setupAdmEmail ) )
							)
						{
							$doLockPage = True;
						}


						// Check the doLockPage flag is set or not
						if ( $doLockPage )
						{
							// Set the error occure flag
							$sess_iserror = 7;
							session_register("sess_iserror");

							// Redirect to error occure page
							// (i.e. lock the page)
							header ('Location: '.$SCRIPT_NAME.'?step='.($sess_iserror));
						}
						else
						{
							// Remove session error flag
							session_unregister("sess_iserror");
						}

						break;
			}
		}
	}



	// send the current charset to the client browser
	header ('Content-Type: text/html; charset='.$default_charset);

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<? echo $default_charset; ?>">
<meta http-equiv="Content-Language" content="<? echo $CONTENT_LANG ?>">
<title><? echo $PROGRAM_NAME; ?></title>
</head>

<style type="text/css">
.help { FONT-SIZE: 8pt; letter-spacing: 0.5px; FONT-FAMILY: <? echo $FONTS ?> }
.title { FONT-SIZE: 12pt; letter-spacing: 0.5px; FONT-FAMILY: <? echo $FONTS ?> }
.head { FONT-SIZE: 14pt; letter-spacing: 0.5px; FONT-FAMILY: <? echo $FONTS ?> }
A:link { COLOR: #FF00FF; text-decoration: none; FONT-SIZE: 8pt }
A:hover { COLOR: #FF00FF! important; LETTER-SPACING: 0pt; text-decoration: underline !important; FONT-SIZE: 8pt }
A:visited { COLOR: #FF00FF; text-decoration: none; FONT-SIZE: 8pt }
h1  { font-size: 20px; color: #999; border-bottom: 2px solid #ccc; }
.smalltd  { font-size: 2px; height: 5px; }
body { font-family: <? echo $FONTS ?>; font-size: 12px; cursor: default; }
<? 
	if ( cssSupport() )
	{
		echo 'font { FONT-SIZE: 10pt; letter-spacing: 0.5px; FONT-FAMILY: '.$FONTS.' }'."\n";
		echo '.loginForm { font-family: '.$FONTS.'; font-size: 12px; font-weight: normal; color: #16246C; text-decoration: none; background-color: #FFFFFF ; border-top-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-width: 1px; border-top-color: #666666; border-bottom-color: #666666; border-left-color: #666666; border-right-color: #666666; }'."\n";
		echo '.button {FONT-FAMILY: '.$FONTS.'; FONT-SIZE: 9pt; PADDING-TOP: 2px; height: 25px; width:80px }'."\n"; 
		echo '.login_footer { FONT-SIZE: 8pt; letter-spacing: 0.5px; FONT-FAMILY: '.$FONTS.' }'."\n";
		$box_size = "30";
	}
	else
		$box_size = "18";


	if ($step == 9 && $buttonNext)
		$toAction = $sess_setupSysURL.'/';
	else
		$toAction = $SCRIPT_NAME.'?step='.($step+1);


?>
</style>

<body bgcolor="#c8f0ff">
<center><br><br>
<form name="setup<? if ($step>0) echo '_'.($step); ?>" method="post" action="<? echo $toAction ?>">
<table border="0" cellpadding="0" cellspacing="0" width="500">
<tr>
	<td width="100%" align="center">
	<h1><? echo $PROGRAM_NAME.'&nbsp;&nbsp;--&nbsp;&nbsp;'.$PROGRAM_VER; ?></h1>
	<? if ( !cssSupport() ) echo '<hr>'; ?>
	</td>
</tr>
<tr>
	<td width="100%" align="center">
	<div align="right" class="help">PHP version : <? echo phpversion() ?></div>
	</td>
</tr>
</table>
<table border="0" cellpadding="1" cellspacing="0" bgcolor="BLACK" width="500"><tr><td>
<table border="0" cellpadding="3" cellspacing="0" bgcolor="#c8f0ff" width="100%">
<tr>
	<td width="100%" bgcolor="#bbbbff" height="30" align="center">
	<font color="#FFFFFF" class="title"><b><? echo $SETUP_MSG ?></b></font>
	</td>
</tr>
<tr>
	<td width="100%" height="100%">
	<table border="0" cellpadding="3" cellspacing="0" bgcolor="#ffffff" width="100%" align="center"><tr><td>
	<table border="0" cellpadding="3" cellspacing="0" width="95%" align="center">
	<tr>		
		<td width="100%" height="25px" align="right"><font color="#000000"><? if ($step > 0 && $step<=$MAX_STEP) echo "Step $step of $MAX_STEP"; ?></font></td>
	</tr>
	<tr>
		<td width="100%" height="25px" align="center">


<!-- Start Script -->
	<?
	if ($step == 1)
	{
	?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
			<font color="#FF0000" class="title"><b><? echo $TXT_LANGUAGE ?></b></font>
			</td>
		</tr>
		<tr>		
			<td width="100%" height="25px" align="left">
			<font color="#000000"><? echo $SELECT_LANG ?></font>
			</td>
		</tr>
		<tr>
			<td width="100%" height="25px" align="center">
			<font color="#000000"><b><? echo $TXT_LANGUAGE ?></b></font>&nbsp;&nbsp;&nbsp;&nbsp;
			<select name="setupLang">
			<?
				$d = dir($OES_INSTALL_PATH.'/include/setup/lang/');
				$i=0;
				while (false !== ($entry = $d->read())) {
					if ( $entry != "." && $entry != ".." ) 
					{
						$temp = split('.lang.php',$entry);
						$langFile[$i++] = strtolower( $temp[0] ).'.lang.php';
					}
				}
				$d->close();

				// Remove duplicate values in array 
				$langFile = arrayNoDuplicate ($langFile);

				// Save current charset
				$chrrentCharset = $default_charset;

				$x = 0;

				// Load the Language Name from language file
				for ( $i=0; $i<count($langFile); $i++ )
				{
					include ($OES_INSTALL_PATH.'/include/setup/lang/'.$langFile[$i]);

					// Store the variables from language file
					$array_LANGNAME [$x++] = array( $LANG_CHARSET, $LANG_NAME , $CONTENT_LANG );
				}

				// Short the language name
				sort( $array_LANGNAME );
				reset ( $array_LANGNAME );

				// display the language choice
				foreach ($array_LANGNAME as $optionLang)
				{
					if ( ereg ( strtolower($default_charset), ( $optionLang[2] = strtolower( $optionLang[2] ) ) ) )
						echo "\n\t\t\t<option selected value=\"".$optionLang[0].'">'.$optionLang[1];
					else
						echo "\n\t\t\t<option value=\"".$optionLang[0].'">'.$optionLang[1];

					if ( strtolower($DEFAULT_SETUP_LANGUAGE) == strtolower($optionLang[0]) )
						echo ' ('.$TXT_DEFAULT.')';
				}

				echo "\n";

				// Load again the current language file
				include ($OES_INSTALL_PATH.'/include/setup/lang/'.strtolower($chrrentCharset).'.lang.php');

			?>
			</select>
			</td>
		</tr>
		</table>
	<?
	}
	elseif ($step == 2)
	{
	?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
			<font color="#FF0000" class="title"><b><? echo $LICENSE_AGREEMENT ?></b></font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" align="left" bgcolor="#cccccc">
			<font color="#000000"><? echo $LICENSE_INFO ?></font>
			</td>
		</tr>
		</table>
	<?
		$show_AGREE_or_DISAGGREE = TRUE;
	}
	elseif ($step == 3)
	{
	?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
			<font color="#FF0000" class="title"><b><? echo $TXT_DATABASE ?></b></font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" align="left">
			<font color="#000000"><? echo $DATABASE_MSG ?></font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" height="10">&nbsp;</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" align="center">
			<font color="#000000"><b><? echo $DATABASE_TYPE ?></b></font>&nbsp;&nbsp;&nbsp;&nbsp;
			<select <? if ( session_is_registered("sess_setupSQLType") && $sess_setupSQLType=='setupSQLType' ) echo 'selected' ?> name="setupSQLType">
			<option <? if ( session_is_registered("sess_setupSQLType") && $sess_setupSQLType=='mssql') echo 'selected' ?> value="mssql">Microsoft SQL Server 
			<option <? if ( session_is_registered("sess_setupSQLType") && $sess_setupSQLType=='vfp') echo 'selected' ?> value="vfp">Microsoft Visual FoxPro 
			<option <? if ( !isset($sess_setupSQLType) || ( session_is_registered("sess_setupSQLType") && $sess_setupSQLType=='mysql') ) echo 'selected' ?> value="mysql">MySQL (Default)
			<option <? if ( session_is_registered("sess_setupSQLType") && $sess_setupSQLType=='odbc') echo 'selected' ?> value="odbc">ODBC
			<option <? if ( session_is_registered("sess_setupSQLType") && $sess_setupSQLType=='ora') echo 'selected' ?> value="ora">Oracle
			<option <? if ( session_is_registered("sess_setupSQLType") && $sess_setupSQLType=='ora8') echo 'selected' ?> value="ora8">Oracle 8
			<option <? if ( session_is_registered("sess_setupSQLType") && $sess_setupSQLType=='pgsql') echo 'selected' ?> value="pgsql">PostgreSQL
 			</select>			
			</td>
		</tr>
		</table>
	<?
	}
	elseif ($step == 4)
	{
		// Store the user choice of Database into session variable
		// (* this part of code is used to complete the Step 3)
		if ( isset($setupSQLType) )
		{
			$sess_setupSQLType = $setupSQLType;
			session_register("sess_setupSQLType");
		}
		// -- End of store database choice --


		// Test the PHP support the database type or NOT
		// (i.e. check the loaded modules)
		if ( chkDBSupport ($sess_setupSQLType) )
//if ( 1 )
		{
	?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
			<font color="#FF0000" class="title"><b><? echo $TXT_DATABASE.' -- '.chkSQLName($sess_setupSQLType) ?></b></font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" align="left">
			<font color="#000000"><? echo $COMPLETE_FORM ?></font>&nbsp;&nbsp;
			<font color="#FF0000" class="help"><b><? echo $STAR_REQUIRE ?></b></font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" height="10">&nbsp;</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" height="10">
			<?
				if ( chkDBIsODBC($sess_setupSQLType) )
				{
				// Output the ODBC setup
				?>
				<table border="0" cellpadding="3" cellspacing="0" width="100%">
				<tr>
					<td width="40%" align="right" valign="top"><font color="#000000"><b>
					<? 
						if ( isset($sess_iserror) && ($sess_setupSQLDomain == '' || ereg(' ',$sess_setupSQLDomain)) )
							echo '<font color="#FF0000"><u>'.$DATABASE_ODBC_SOURCE.'</u></font>';
						else
							echo $DATABASE_ODBC_SOURCE;
					?>
					</b></font></td>
					<td width="5%" align="center">&nbsp;</td>
					<td width="55%" align="left">
						<input class="loginForm" type="text" name="setupSQLDomain" value="<? echo $sess_setupSQLDomain ?>" size="<? echo $box_size ?>" maxlength="250" tabindex="1">&nbsp;
						<font color="#FF0000"><b>*</b></font><br>
						<font color="#aaaaaa" class="help"><? echo $DATABASE_ODBC_SOURCE_HLP ?></font>
					</td>
				</tr>
				<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</tr></tr>
				<tr>
					<td width="40%" align="right" valign="top"><font color="#000000"><b>
					<? 
						if ( isset($sess_iserror) && ($sess_setupSQLAccount == '' || ereg(' ',$sess_setupSQLAccount)) )
							echo '<font color="#FF0000"><u>'.$DATABASE_ACC_NAME.'</u></font>';
						else
							echo $DATABASE_ACC_NAME;
					?>
					</b></font></td>
					<td width="5%" align="center">&nbsp;</td>
					<td width="55%" align="left">
						<input class="loginForm" type="text" name="setupSQLAccount" value="<? echo $sess_setupSQLAccount ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="3">&nbsp;
					</td>
				</tr>
				<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</tr></tr>
				<tr>
					<td width="40%" align="right" valign="top"><font color="#000000"><b>
					<? 
						if ( isset($sess_iserror) && ($sess_setupSQLPassword == '' || ereg(' ',$sess_setupSQLPassword)) )
						{
							echo '<font color="#FF0000"><u>'.$DATABASE_ACC_PWD.'</u></font>';
							$sess_setupSQLPassword = '';
						}
						else
							echo $DATABASE_ACC_PWD;
					?>
					</b></font></td>
					<td width="5%" align="center">&nbsp;</td>
					<td width="55%" align="left">
						<input class="loginForm" type="password" name="setupSQLPassword" value="<? echo $sess_setupSQLPassword ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="4">&nbsp;
					</td>
				</tr>
				</table>
				<?
				}
				else
				{
				// Output NON-ODBC setup
			?>
			<table border="0" cellpadding="3" cellspacing="0" width="100%">
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && ($sess_setupSQLDomain == '' || ereg(' ',$sess_setupSQLDomain)) )
						echo '<font color="#FF0000"><u>'.$DATABASE_DOMAIN.'</u></font>';
					else
						echo $DATABASE_DOMAIN;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSQLDomain" value="<? echo $sess_setupSQLDomain ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="1">&nbsp;
					<br>
					<font color="#aaaaaa" class="help"><? echo $DATABASE_DOMAIN_HLP ?></font>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if (	isset($sess_iserror) &&
							( $sess_setupSQLPort!='' && 
								(
								 $sess_setupSQLPort <= 0 || 
								 $sess_setupSQLPort != intval($sess_setupSQLPort) || 
								 ( !is_numeric($sess_setupSQLPort) )
								)
							) || 
							strlen($sess_setupSQLPort)>6 || 
							ereg(' ',$sess_setupSQLPort) 
					   )
						echo '<font color="#FF0000"><u>'.$DATABASE_PORT.'</u></font>';
					else
						echo $DATABASE_PORT;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSQLPort" value="<? echo $sess_setupSQLPort ?>" size="10" maxlength="6" tabindex="2"><br>
					<font color="#aaaaaa" class="help"><? echo $DATABASE_PORT_HLP ?></font>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && ($sess_setupSQLDB == '' || ereg(' ',$sess_setupSQLDB)) )
						echo '<font color="#FF0000"><u>'.$DATABASE_DBNAME.'</u></font>';
					else
						echo $DATABASE_DBNAME;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSQLDB" value="<? echo $sess_setupSQLDB ?>" size="<? echo $box_size ?>" maxlength="250" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
					<font color="#aaaaaa" class="help"><? echo $DATABASE_DBNAME_HLP ?></font>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && ($sess_setupSQLAccount == '' || ereg(' ',$sess_setupSQLAccount)) )
						echo '<font color="#FF0000"><u>'.$DATABASE_ACC_NAME.'</u></font>';
					else
						echo $DATABASE_ACC_NAME;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSQLAccount" value="<? echo $sess_setupSQLAccount ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="3">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && ($sess_setupSQLPassword == '' || ereg(' ',$sess_setupSQLPassword)) )
					{
						echo '<font color="#FF0000"><u>'.$DATABASE_ACC_PWD.'</u></font>';
						$sess_setupSQLPassword = '';
					}
					else
						echo $DATABASE_ACC_PWD;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="password" name="setupSQLPassword" value="<? echo $sess_setupSQLPassword ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="4">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			</table>
			<?
				}
			?>
			</td>
		</tr>
		</table>
	<?
		}
		else
		{
			// Set noNextPage flag to True
			$noNextPage = True;

			// Tell the user, the PHP environment donn't support this type of database server
			?>
			<table border="0" cellpadding="3" cellspacing="0" width="100%">
			<tr>		
				<td width="100%" height="25px" align="left">
				<font color="#FF0000" class="title"><b><? echo $TXT_DATABASE.' -- '.chkSQLName($sess_setupSQLType) ?></b></font>
				</td>
			</tr>
			<tr align="center" valign="top">		
				<td width="100%" align="left">
				<font color="#000000"><? echo $DATABASE_DONNT_SUPPORT ?></font>&nbsp;&nbsp;
				</td>
			</tr>
			</table>
			<?
		}
	}
	elseif ($step == 5)
	{
		// Save the database variable into session received from prev. page
		if ( isset($setupSQLDomain) )
		{
			$sess_setupSQLDomain   = $setupSQLDomain;
			session_register("sess_setupSQLDomain");
		}

		if ( isset($setupSQLPort) )
		{
			$sess_setupSQLPort     = $setupSQLPort;							
			session_register("sess_setupSQLPort");
		}

		if ( isset($setupSQLDB) )
		{
			$sess_setupSQLDB	   = $setupSQLDB;							
			session_register("sess_setupSQLDB");
		}

		if ( isset($setupSQLAccount) )
		{
			$sess_setupSQLAccount  = $setupSQLAccount;
			session_register("sess_setupSQLAccount");
		}

		if ( isset($setupSQLPassword) )
		{
			$sess_setupSQLPassword = $setupSQLPassword;
			session_register("sess_setupSQLPassword");
		}
		// -- End of save database variable --

	?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
			<font color="#FF0000" class="title"><b><? echo $DATABASE_CONNECT.' -- '.chkSQLName($sess_setupSQLType) ?></b></font>
			</td>
		</tr>
		<tr align="center" valign="top" bgcolor="#ecffe6">		
<!-- 	<tr align="center" valign="top" bgcolor="#c8f0ff">		-->
			<td width="100%" align="left" height="300">
			<font color="#000000">
				<? 
					// *** Do SQL server connection test ***

					// Include the ADBdb libriry
					include_once ($OES_INSTALL_PATH.'/include/adodb/adodb.inc.php');


					// Connect to the SQL server using ADOdb library
					$db = ADONewConnection(db2adodb($sess_setupSQLType));
					$db->debug = false;
					if ( chkDBIsODBC($sess_setupSQLType) )
					{
						// The server type is ODBC, remove PORT setting
						session_unregister("sess_setupSQLPort");
					}
					else
					{
						// Check the sql server with different port
						if ( $sess_setupSQLPort )
							$sqlServer = $sess_setupSQLDomain.":".$sess_setupSQLPort;
						else
							$sqlServer = $sess_setupSQLDomain;
					}

					// If user provide the database name, auto change to that database.
					if ( $sess_setupSQLDB )
						$db->database = $sess_setupSQLDB;

					// Create Connection
					@ $conn = $db->Connect($sqlServer, $sess_setupSQLAccount, $sess_setupSQLPassword);

					if ( $sqlServer=='' )
						$serverName = 'localhost';
					else
						$serverName = $sqlServer;

					// Display the connection result
					if ( !$conn )
					{
						// Connection Faile
						echo $DATABASE_CONNECT_TO.'&nbsp;\'<b>'.$serverName.'</b>\'&nbsp;.&nbsp;.&nbsp;.&nbsp;.&nbsp;.&nbsp;.&nbsp;&nbsp;<b>'.$TXT_FAILED.'</b><BR><BR>'."\n";
						flush(); 

						// If the ErrorMsg() store some error message, display it
						if ( $db->ErrorMsg() )
							echo $TXT_REASON.' : <b>'.$db->ErrorMsg().'</b>';
						else
							// Check connection
							echo $DATABASE_ERR_REASONALL.'<BR><BR>'."\n";

						// Lock the current page
						$noNextPage = TRUE;						
					}
					else
					{
						// Connection Success
						echo $DATABASE_CONNECT_TO.'&nbsp;\'<b>'.$serverName.'</b>\'&nbsp;.&nbsp;.&nbsp;.&nbsp;.&nbsp;.&nbsp;.&nbsp;&nbsp;<b>'.$TXT_SUCCESS.'</b><BR><BR>'."\n";
						flush(); 

						
						/* --- Removed Function ---
						if ( !$sess_setupSQLDB )
						{
							// -- Create the database if user not provide. (non-odbc only)
							// ..........................................................
							// ..........................................................
							// ..........................................................
							// ..........................................................

							echo $DATABASE_ERR_NODATABASE."<br>\n";
							echo $DATABASE_CREATE_DATABASE.'&nbsp;&nbsp;\'db-oes\''."&nbsp;.&nbsp;.&nbsp;.&nbsp;.&nbsp;.&nbsp;.&nbsp;<br>\n";
						}
						*/


						// The database name is appear and loaded
						// Do create table
						if ( $sess_setupSQLDB )
						{
							// Show which database is using
							echo $DATABASE_DBNAME.' : \'<b>'.$sess_setupSQLDB."</b>'<br>\n";

							// Include SQL table 'sql-table-xxxx.inc.php'
							@include ($OES_INSTALL_PATH.'/include/sql-table-'.$sess_setupSQLType.'.inc.php');

							// Counter store success created table number
							$num = 0;

							// Loop to create all table which is required for OES
							// (This is a TEST only, the created table will drop after the test)
							for ( $i=0; $i<count($CREATETABLE); $i++ )
							{
								// Create the TABLE on database
								if ( !$db->Execute($CREATETABLE[$i]) )
								{
									// Display Create Faile message
									echo $DATABASE_CREATE_TABLE_TEST.' [ '.$DBTABLE_NAME[$i].' ]&nbsp;.&nbsp;.&nbsp;. <b>'.$TXT_FAILED."</b><br>\n";

									// Save the error reason
									$errReason .=  $db->ErrorMsg()."<br>\n";

									// Error occure, lock the page
									$noNextPage = TRUE;
								}
								else
								{
									// Display Create Success message
									echo $DATABASE_CREATE_TABLE_TEST.' [ '.$DBTABLE_NAME[$i].' ]&nbsp;.&nbsp;.&nbsp;. <b>'.$TXT_SUCCESS."</b><br>\n";

									// Save the table name which is successful create
									// (for drop it use)
									$CREATED_TABLE[$num++] = $DBTABLE_NAME[$i];
								}

							}


							if ( $errReason )
							{
								// Some error occure, display error message
								echo "<br>\n<b>".$TXT_REASON."</b> :<br>\n".$errReason."<br>\n";
								echo '<b>'.$DATABASE_ERR_TABLEEXIST."</b><br>\n";
								echo "<br>\n";
							}
							else
								// No Error occure, display database perpare successful
								echo "<br><br>\n<b>".$DATABASE_CREATE_SUCCESS."</b><br>\n";

						
							// Drop the created table, although have error
							if ( count($CREATED_TABLE) )
							{
								// Error occure, drop the created table
								for ( $i=0; $i<count($CREATED_TABLE); $i++ )
								{
									// This query should work on MySQL
									$QUERY = 'DROP TABLE '.$CREATED_TABLE[$i];

									if ( $db->Execute($QUERY) )
									{
										if ( $errReason )
											// Show Drop table message
											echo $DATABASE_ERR_DROPTAB.'&nbsp;&nbsp;\''.$CREATED_TABLE[$i]."'&nbsp;.&nbsp;.&nbsp;.&nbsp;&nbsp;<b>$TXT_SUCCESS</b><br>\n";
									}
									else
									{
										// Can't DROP the table
										echo $DATABASE_ERR_DROPTAB.'&nbsp;&nbsp;\''.$CREATED_TABLE[$i]."'&nbsp;.&nbsp;.&nbsp;.&nbsp;&nbsp;<b>$TXT_FAILED</b><br>\n";
									}


							
									// Do the extra DROP table for PostgreSQL only
									if (db2adodb($sess_setupSQLType) == 'postgres')
									{
										// This query only for PostgreSQL
										$QUERY = 'DROP SEQUENCE '.$CREATED_TABLE[$i].'_id_seq';

										// Remove the sequence 
										if ( $db->Execute($QUERY) )
										{
											if ( $errReason )
												// Show Drop table message
												echo $DATABASE_ERR_DROPTAB.'&nbsp;&nbsp;\''.$CREATED_TABLE[$i]."'&nbsp;.&nbsp;.&nbsp;.&nbsp;&nbsp;<b>$TXT_SUCCESS</b><br>\n";
										}
										else
										{
											// Can't DROP the table
											echo $DATABASE_ERR_DROPTAB.'&nbsp;&nbsp;\''.$CREATED_TABLE[$i]."'&nbsp;.&nbsp;.&nbsp;.&nbsp;&nbsp;<b>$TXT_FAILED</b><br>\n";
										}
									}
									// -- End --

								}
							}
						}
					}
				?>
			</font>
			</td>
		</tr>
		</table>
	<?
	}
	elseif ($step == 6)
	{
		// *** If this is first time lunch Step 6 ***

		// Retrieval the OES install path (i.e. the root of OES)
		if ( !isset($sess_setupSysInstallPath) || $sess_setupSysInstallPath == '' )
		{
			// Get the current path
			// e.g. UNIX  =>  /var/www/oes/htdocs
			//      WIN   =>  c:\oes\htdocs
			// then use 'htdocs' to split the string, and assume left side 
			// will be the install path of OES.
			$installPath = split('users/htdoc', getcwd());

			// Check the splited array, the first part must no NULL
			for ( $i=0; $i<count($installPath); $i++ )
			{
				if ( strlen($installPath[$i]) > 1 )
				{
					// Assume this path is the install path
					$installPath = $installPath[$i];
					
					// Stop the loop
					break;
				}
			}

			// Remove tha last '/' or '\'
			if ( !ereg('([0-9a-zA-Z])', $setupSysInstallPath[strlen($setupSysInstallPath) - 1] ) )
				$installPath = substr ( $installPath, 0, (strlen($installPath) - 1) );

			$sess_setupSysInstallPath = $installPath;
		}


		// Set all path to default
		if ( !isset($sess_setupSysConfigPath) || $sess_setupSysConfigPath == '' )
			$sess_setupSysConfigPath		= DEFAULT_setupSysConfigPath;

		if ( !isset($sess_setupSysIncludePath) || $sess_setupSysIncludePath == '' )
			$sess_setupSysIncludePath		= DEFAULT_setupSysIncludePath;

		if ( !isset($sess_setupSysThemesPath) || $sess_setupSysThemesPath == '' )
			$sess_setupSysThemesPath		= DEFAULT_setupSysThemesPath;

		if ( !isset($sess_setupSysModulesPath) || $sess_setupSysModulesPath == '' )
			$sess_setupSysModulesPath		= DEFAULT_setupSysModulesPath;

		if ( !isset($sess_setupSysAdminPath) || $sess_setupSysAdminPath == '' )
			$sess_setupSysAdminPath			= DEFAULT_setupSysAdminPath;

		if ( !isset($sess_setupSysAdminThemes) || $sess_setupSysAdminThemes == '' )
			$sess_setupSysAdminThemes		= DEFAULT_setupSysAdminThemes;

		if ( !isset($sess_setupSysAdminModules) || $sess_setupSysAdminModules == '' )
			$sess_setupSysAdminModules		= DEFAULT_setupSysAdminModules;

		if ( !isset($sess_setupSysSessionPath) || $sess_setupSysSessionPath == '' )
			$sess_setupSysSessionPath		= DEFAULT_setupSysSessionPath;

		if ( !isset($sess_setupSysSessionAdmPath) || $sess_setupSysSessionAdmPath == '' )
			$sess_setupSysSessionAdmPath	= DEFAULT_setupSysSessionAdmPath;



		// Retrieval the current OES URL
		if ( !isset($sess_setupSysURL) || $sess_setupSysURL == '' )
		{
			// Find the current URL
			$scriptPath = $PHP_SELF;
			$scriptPath = split( basename ($scriptPath) , $scriptPath);
			$scriptPath = $scriptPath[0];

			// Remove the last '/'
			if ( !ereg('([0-9a-zA-Z])', $scriptPath[strlen($scriptPath) - 1] ) )
				$scriptPath = substr ( $scriptPath, 0, (strlen($scriptPath) - 1) );

			$sess_setupSysURL				= 'http://'.$_SERVER["HTTP_HOST"].$scriptPath;
		}


		// Default Administration URL = OES URL + '/admin'
		if ( !isset($sess_setupSysAdminURL) || $sess_setupSysAdminURL == '' )
		{
			$sess_setupSysAdminURL			= $sess_setupSysURL.'/admin';
		}

		// *** End of decaration for first time lunch step 6 ***

	?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
			<font color="#FF0000" class="title"><b><? echo $SYS_ENV ?></b></font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" align="left">
			<font color="#000000"><? echo $SYS_ENV_MSG ?></font>
			</td>
		</tr>
		<tr><td height="20px">&nbsp;</td></tr>
		<tr><td>
			<table border="0" cellpadding="3" cellspacing="0" width="100%">
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysInstallPath == '' ||
						   ereg(' ',$sess_setupSysInstallPath) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysInstallPath[strlen($sess_setupSysInstallPath) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_INSTALL_PATH.'</u></font>';
					else
						echo $SYS_INSTALL_PATH;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysInstallPath" value="<? echo $sess_setupSysInstallPath ?>" size="<? echo $box_size ?>" maxlength="250" tabindex="1">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr align="center" valign="top">		
				<td width="100%" align="left" colspan="3">
				<font color="#000000"><hr><? echo $SYS_OTHER_PATH_MSG ?></font>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysConfigPath == '' ||
						   ereg(' ',$sess_setupSysConfigPath) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysConfigPath[strlen($sess_setupSysConfigPath) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_CONFIG_PATH.'</u></font>';
					else
						echo $SYS_CONFIG_PATH;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysConfigPath" value="<? echo $sess_setupSysConfigPath ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysIncludePath == '' ||
						   ereg(' ',$sess_setupSysIncludePath) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysIncludePath[strlen($sess_setupSysIncludePath) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_INCLUDE_PATH.'</u></font>';
					else
						echo $SYS_INCLUDE_PATH;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysIncludePath" value="<? echo $sess_setupSysIncludePath ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysThemesPath == '' ||
						   ereg(' ',$sess_setupSysThemesPath) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysThemesPath[strlen($sess_setupSysThemesPath) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_THEMES_PATH.'</u></font>';
					else
						echo $SYS_THEMES_PATH;
				?>				
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysThemesPath" value="<? echo $sess_setupSysThemesPath ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysModulesPath == '' ||
						   ereg(' ',$sess_setupSysModulesPath) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysModulesPath[strlen($sess_setupSysModulesPath) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_MODULES_PATH.'</u></font>';
					else
						echo $SYS_MODULES_PATH;
				?>				
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysModulesPath" value="<? echo $sess_setupSysModulesPath ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysAdminPath == '' ||
						   ereg(' ',$sess_setupSysAdminPath) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysAdminPath[strlen($sess_setupSysAdminPath) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_ADMIN_PATH.'</u></font>';
					else
						echo $SYS_ADMIN_PATH;
				?>				
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysAdminPath" value="<? echo $sess_setupSysAdminPath ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysAdminThemes == '' ||
						   ereg(' ',$sess_setupSysAdminThemes) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysAdminThemes[strlen($sess_setupSysAdminThemes) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_ADMIN_THEMES.'</u></font>';
					else
						echo $SYS_ADMIN_THEMES;
				?>				
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysAdminThemes" value="<? echo $sess_setupSysAdminThemes ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysAdminModules == '' ||
						   ereg(' ',$sess_setupSysAdminModules) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysAdminModules[strlen($sess_setupSysAdminModules) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_ADMIN_MODULES.'</u></font>';
					else
						echo $SYS_ADMIN_MODULES;
				?>				
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysAdminModules" value="<? echo $sess_setupSysAdminModules ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysSessionPath == '' ||
						   ereg(' ',$sess_setupSysSessionPath) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysSessionPath[strlen($sess_setupSysSessionPath) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_SESSION_PATH.'</u></font>';
					else
						echo $SYS_SESSION_PATH;
				?>				
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysSessionPath" value="<? echo $sess_setupSysSessionPath ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysSessionAdmPath == '' ||
						   ereg(' ',$sess_setupSysSessionAdmPath) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysSessionAdmPath[strlen($sess_setupSysSessionAdmPath) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_SESSIONADM_PATH.'</u></font>';
					else
						echo $SYS_SESSIONADM_PATH;
				?>				
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysSessionAdmPath" value="<? echo $sess_setupSysSessionAdmPath ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr align="center" valign="top">		
				<td width="100%" align="left" colspan="3"><hr>
				<font color="#000000"><? echo $SYS_URL_MSG ?></font><br>
				<center>
					<table border="0" cellpadding="3" cellspacing="0" width="85%">
					<tr>
						<td width="45%" align="right"><font color="#aaaaaa"><? echo $SYS_URL ?></font></td>
						<td width="05%" align="center"><font color="#aaaaaa">=</font></td>
						<td width="50%" align="left"><font color="#aaaaaa">http://your.domain</font></td>
					</tr>
					<tr>
						<td width="45%" align="right"><font color="#aaaaaa"><? echo $SYS_ADMIN_URL ?></font></td>
						<td width="05%" align="center"><font color="#aaaaaa">=</font></td>
						<td width="50%" align="left"><font color="#aaaaaa">http://your.domain/admin</font></td>
					</tr>
					</table>
				</center>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysURL == '' ||
						   ereg(' ',$sess_setupSysURL) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysURL[strlen($sess_setupSysURL) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_URL.'</u></font>';
					else
						echo $SYS_URL;
				?>				
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysURL" value="<? echo $sess_setupSysURL ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && 
						 ( $sess_setupSysAdminURL == '' ||
						   ereg(' ',$sess_setupSysAdminURL) ||
						   !ereg('([0-9a-zA-Z])', $sess_setupSysAdminURL[strlen($sess_setupSysAdminURL) - 1] )
						 )
					   )
						echo '<font color="#FF0000"><u>'.$SYS_ADMIN_URL.'</u></font>';
					else
						echo $SYS_ADMIN_URL;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupSysAdminURL" value="<? echo $sess_setupSysAdminURL ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			</table>
		</td></tr>
		</table>
	<?
	}
	elseif ($step == 7)
	{
		// Save the system environment variable into session received from prev. page
		if ( isset($setupSysInstallPath) )
		{
			$sess_setupSysInstallPath		= $setupSysInstallPath;
			session_register("sess_setupSysInstallPath");
		}

		if ( isset($setupSysConfigPath) )
		{
			$sess_setupSysConfigPath		= $setupSysConfigPath;							
			session_register("sess_setupSysConfigPath");
		}

		if ( isset($setupSysIncludePath) )
		{
			$sess_setupSysIncludePath		= $setupSysIncludePath;							
			session_register("sess_setupSysIncludePath");
		}

		if ( isset($setupSysThemesPath) )
		{
			$sess_setupSysThemesPath		= $setupSysThemesPath;
			session_register("sess_setupSysThemesPath");
		}

		if ( isset($setupSysModulesPath) )
		{
			$sess_setupSysModulesPath		= $setupSysModulesPath;
			session_register("sess_setupSysModulesPath");
		}

		if ( isset($setupSysAdminPath) )
		{
			$sess_setupSysAdminPath		= $setupSysAdminPath;
			session_register("sess_setupSysAdminPath");
		}

		if ( isset($setupSysAdminThemes) )
		{
			$sess_setupSysAdminThemes	= $setupSysAdminThemes;
			session_register("sess_setupSysAdminThemes");
		}

		if ( isset($setupSysAdminModules) )
		{
			$sess_setupSysAdminModules	= $setupSysAdminModules;
			session_register("sess_setupSysAdminModules");
		}

		if ( isset($setupSysSessionPath) )
		{
			$sess_setupSysSessionPath		= $setupSysSessionPath;
			session_register("sess_setupSysSessionPath");
		}

		if ( isset($setupSysSessionAdmPath) )
		{
			$sess_setupSysSessionAdmPath	= $setupSysSessionAdmPath;
			session_register("sess_setupSysSessionAdmPath");
		}

		if ( isset($setupSysURL) )
		{
			$sess_setupSysURL				= $setupSysURL;
			session_register("sess_setupSysURL");
		}

		if ( isset($setupSysAdminURL) )
		{
			$sess_setupSysAdminURL			= $setupSysAdminURL;
			session_register("sess_setupSysAdminURL");
		}
		// -- End of save system environment variable --

	?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
			<font color="#FF0000" class="title"><b><? echo $ADMIN_SETUP ?></b></font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" align="left">
			<font color="#000000"><? echo $ADMIN_SETUP_MSG ?></font>
			</td>
		</tr>
		<tr><td height="20px">&nbsp;</td></tr>
		<tr><td>
			<table border="0" cellpadding="3" cellspacing="0" width="100%">
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && ($sess_setupAdmID == '' || ereg(' ',$sess_setupAdmID)) )
						echo '<font color="#FF0000"><u>'.$ADMIN_ID.'</u></font>';
					else
						echo $ADMIN_ID;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupAdmID" value="<? echo $sess_setupAdmID ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="1">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && ($sess_setupAdmPwd == '' || ereg(' ',$sess_setupAdmPwd)) ||
						 $sess_setupAdmPwd != $sess_setupAdmPwdAgain )
					{
						echo '<font color="#FF0000"><u>'.$ADMIN_PASSWORD.'</u></font>';
						
						// Any one password field have error, clear all password
						$sess_setupAdmPwd      = '';
						$sess_setupAdmPwdAgain = '';
					}
					else
						echo $ADMIN_PASSWORD;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="password" name="setupAdmPwd" value="<? echo $sess_setupAdmPwd ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="2">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && ($sess_setupAdmPwdAgain == '' || ereg(' ',$sess_setupAdmPwdAgain)) ||
						 $sess_setupAdmPwd != $sess_setupAdmPwdAgain )
					{
						echo '<font color="#FF0000"><u>'.$ADMIN_PASSWORD_AGAIN.'</u></font>';
						
						// Any one password field have error, clear all password
						$sess_setupAdmPwd      = '';
						$sess_setupAdmPwdAgain = '';
					}
					else
						echo $ADMIN_PASSWORD_AGAIN;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="password" name="setupAdmPwdAgain" value="<? echo $sess_setupAdmPwdAgain ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="3">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b><? echo $ADMIN_LANG ?></b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<font color="#000000"><? echo $ADMIN_LANG_DEFAULT ?></font><br>
				</td>
			</tr>
			<tr><td colspan="3" height="5px" class="smalltd">&nbsp;</td></tr>
			<tr>
				<td width="40%" align="right" valign="top"><font color="#000000"><b>
				<? 
					if ( isset($sess_iserror) && ($sess_setupAdmEmail == '' || ereg(' ',$sess_setupAdmEmail) || 
						( isset($sess_setupAdmEmail) && !vaidEmail($sess_setupAdmEmail) )) )
					{
						// Don't show wrong email if first run

						echo '<font color="#FF0000"><u>'.$ADMIN_EMAIL.'</u></font>';
					}
					else
						echo $ADMIN_EMAIL;
				?>
				</b></font></td>
				<td width="5%" align="center">&nbsp;</td>
				<td width="55%" align="left">
					<input class="loginForm" type="text" name="setupAdmEmail" value="<? echo $sess_setupAdmEmail ?>" size="<? echo $box_size ?>" maxlength="60" tabindex="4">&nbsp;
					<font color="#FF0000"><b>*</b></font><br>
				</td>
			</tr>
			</table>
		</td></tr>
		</table>
	<?
	}
	elseif ($step == 8)
	{
		// Save the administrator account variable into session received from prev. page
		if ( isset($setupAdmID) )
		{
			$sess_setupAdmID		= $setupAdmID;
			session_register("sess_setupAdmID");
		}

		if ( isset($setupAdmPwd) )
		{
			$sess_setupAdmPwd		= $setupAdmPwd;
			session_register("sess_setupAdmPwd");
		}

		if ( isset($setupAdmPwdAgain) )
		{
			$sess_setupAdmPwdAgain	= $setupAdmPwdAgain;
			session_register("sess_setupAdmPwdAgain");
		}

		if ( isset($setupAdmEmail) )
		{
			$sess_setupAdmEmail		= $setupAdmEmail;
			session_register("sess_setupAdmEmail");
		}
		// -- End of save administrator account variable --
		?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
			<font color="#FF0000" class="title"><b><? echo $CONFIRM ?></b></font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" align="left">
			<font color="#000000"><? echo $CONFIRM_MSG ?></font>
			</td>
		</tr>
		<tr align="center" valign="top" bgcolor="#ecffe6">		
			<td width="100%" align="center" height="300">
				<font color="#000000" class="help">
				<table border="0" cellpadding="3" cellspacing="0" width="100%">
				<tr>
					<td colspan="3" align="left"><b><u><? echo $TXT_DATABASE ?></u></b></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $DATABASE_TYPE ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo chkSQLName($sess_setupSQLType) ?></td>
				</tr>
				<?
					if ( !chkDBIsODBC($sess_setupSQLType) )
					{
						// Show NON-ODBC setting
				?>
				<tr>
					<td width="45%" align="left"><? echo $DATABASE_DOMAIN ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? if ( $sess_setupSQLDomain != '' ) echo $sess_setupSQLDomain; else echo $TXT_DEFAULT; ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $DATABASE_PORT ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? if ( $sess_setupSQLPort != '' ) echo $sess_setupSQLPort; else echo $TXT_DEFAULT; ?></td>
				</tr>
				<?
					}
					else
					{
				?>
				<tr>
					<td width="45%" align="left"><? echo $DATABASE_ODBC_SOURCE ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSQLDomain ?></td>
				</tr>
				<?
						// Show ODBC setting
					}
				?>
				<tr>
					<td width="45%" align="left"><? echo $DATABASE_DBNAME ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSQLDB ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $DATABASE_ACC_NAME ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSQLAccount ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $DATABASE_ACC_PWD ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSQLPassword ?></td>
				</tr>
				<tr>
					<td colspan="3" height="20px">&nbsp;</td>
				</tr>
				<tr>
					<td colspan="3" align="left"><b><u><? echo $SYS_ENV ?></u></b></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_INSTALL_PATH ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysInstallPath ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_CONFIG_PATH ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysConfigPath ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_INCLUDE_PATH ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysIncludePath ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_THEMES_PATH ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysThemesPath ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_MODULES_PATH ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysModulesPath ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_ADMIN_PATH ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysAdminPath ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_ADMIN_THEMES ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysAdminThemes ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_ADMIN_MODULES ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysAdminModules ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_SESSION_PATH ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysSessionPath ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_SESSIONADM_PATH ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysSessionAdmPath ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_URL ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysURL ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $SYS_ADMIN_URL ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupSysAdminURL ?></td>
				</tr>
				<tr>
					<td colspan="3" height="20px">&nbsp;</td>
				</tr>
				<tr>
					<td colspan="3" align="left"><b><u><? echo $ADMIN_SETUP ?></u></b></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $ADMIN_ID ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupAdmID ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $ADMIN_PASSWORD ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $TXT_ENCRYPTED ?></td>
				</tr>
				<tr>
					<td width="45%" align="left"><? echo $ADMIN_EMAIL ?></td>
					<td width="10%" align="center">=</td>
					<td width="45%" align="left"><? echo $sess_setupAdmEmail ?></td>
				</tr>
				</table>
				</font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" align="left">
			<font color="#000000"><? echo $CONFIRM_NEXT_MSG ?></font>
			</td>
		</tr>
		</table>
		<?
	}
	elseif ($step == 9 && $buttonNext)
	{
		// Generate the Configuration file
		$configFile = $OES_INSTALL_PATH.DEFAULT_setupSysConfigPath.'/'.DEFAULT_configFile;

		// Default Configuration file templet
		$configTemplete = $OES_INSTALL_PATH.DEFAULT_setupSysIncludePath.'/setup/'.DEFAULT_configFileTemplet;

		if ( !session_is_registered("isComplete") )
		{
			// Open the default configuration file templet
			@ $fp = fopen ($configTemplete , "r");
			if ( $fp && filesize($configTemplete) )
			{
				// Load the default configuration file templet
				$confTemplete = fread( $fp, filesize($configTemplete) );

				// do replace the unknow from templates
				@ $confTemplete =	str_replace( "// File        : /include/setup/config.inc", "// File        : /conf/config.inc.php", $confTemplete );
				@ $confTemplete =	str_replace( "// Description : Template of configuration file.", "// Description : Configuration file.", $confTemplete );
				@ $confTemplete =	ereg_replace( '\{INSTALLED_PATH\}'   , $sess_setupSysInstallPath	, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{INSTALLED_URL\}'    , $sess_setupSysURL			, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{DB_TYPE\}'          , $sess_setupSQLType			, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{DB_ADDR\}'          , $sess_setupSQLDomain			, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{DB_PORT\}'          , $sess_setupSQLPort			, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{DB_NAME\}'          , $sess_setupSQLDB				, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{DB_USER\}'          , $sess_setupSQLAccount		, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{DB_PWD\}'           , $sess_setupSQLPassword		, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{ADM_PATH\}'         , $sess_setupSysAdminPath		, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{ADM_THEMES_PATH\}'  , $sess_setupSysAdminThemes	, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{ADM_MODULES_PATH\}' , $sess_setupSysAdminModules	, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{ADM_SESSION_PATH\}' , $sess_setupSysSessionAdmPath	, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{ADM_URL\}'          , $sess_setupSysAdminURL		, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{CONFIG_PATH\}'      , $sess_setupSysConfigPath		, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{INCLUDE_PATH\}'     , $sess_setupSysIncludePath	, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{THEMES_PATH\}'      , $sess_setupSysThemesPath		, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{MODULES_PATH\}'     , $sess_setupSysModulesPath	, $confTemplete );
				@ $confTemplete =	ereg_replace( '\{SESSION_PATH\}'     , $sess_setupSysSessionPath	, $confTemplete );
				// end of replace unknow


				// Save the setting into configuration file
				@ $fp_write = fopen ( $configFile, "w" );
				if ( !$fp_write )
				{
					echo 'Can\'t write to configuration file!!<br>'.$configFile."<br>\n";
					$isErr = True;
				}
				else
					if ( !fwrite( $fp_write, ($confTemplete) ) )
					{
						echo 'Can\'t write to configuration file!!<br>'.$configFile."<br>\n";
						$isErr = True;
					}

				// Close the file for write
				@ fclose ( $fp_write );


				// Include the ADODB library
				include_once ($OES_INSTALL_PATH.'/include/adodb/adodb.inc.php');

				// Do create the administrator account in database
				$db = ADONewConnection(db2adodb($sess_setupSQLType));
				$db->debug = false;
				if ( chkDBIsODBC($sess_setupSQLType) )
					// The server type is ODBC, remove PORT setting
					session_unregister("sess_setupSQLPort");
				else
				{
					// Check the sql server with different port
					if ( $sess_setupSQLPort )
						$sqlServer = $sess_setupSQLDomain.":".$sess_setupSQLPort;
					else
						$sqlServer = $sess_setupSQLDomain;
				}

				// If user provide the database name, auto change to that database.
				if ( $sess_setupSQLDB )
					$db->database = $sess_setupSQLDB;

				// Create Connection
				@ $conn = $db->Connect($sqlServer, $sess_setupSQLAccount, $sess_setupSQLPassword);

				// Display the connection result
				if ( !$conn )
				{
					// -- Connection Error --
					// If the ErrorMsg() store some error message, display it
					if ( $db->ErrorMsg() )
					{
						echo $db->ErrorMsg()."<br><br>\n";
						$isErr = True;
					}
					else
						// Check connection
						echo $DATABASE_ERR_REASONALL.'<BR><BR>'."\n";
				}
				else
				{
					// -- Connection success --

					// include the SQL table
					include ($OES_INSTALL_PATH.'/include/sql-table-'.$sess_setupSQLType.'.inc.php');

					// Loop to create all table which is required for OES
					for ( $i=0; $i<count($CREATETABLE); $i++ )
					{
						// Create the TABLE on database
						if ( !$db->Execute($CREATETABLE[$i]) )
						{
							// Error on create table
							echo  $db->ErrorMsg()."<br>\n";
							$isErr = True;
						}
					}

					// Encypt the administrator password
					$encyptPwd = encryptString ($sess_setupAdmPwd, 250);

					// Get current date and time
					$createDate = date("Y-m-d H:i:s");

				
					// Get the next avaliable ID (key)
					$nextGID = $db->GenID('oes_group_id_seq');

					// Perpare the Query of create the ROOT group
					$query = "INSERT INTO oes_group VALUES ('$nextGID', 'Y', 'ROOT', 'Root administrator team')";

					if ( !$db->Execute($query) )
					{
						// Error on create table
						echo  $db->ErrorMsg()."<br>\n";
						$isErr = True;
					}


					// Get the next avaliable ID (key)
					$nextID = $db->GenID('adm_users_id_seq');
					
					// Perpare the Query of create the administrator
					$query = "INSERT INTO adm_users VALUES ('$nextID', 'Y', '$nextGID', '$sess_setupAdmID', '$encyptPwd', 'ROOT ADMIN', ".
						     "'Administrator', '$sess_setupAdmEmail', '0', 'EN ', '', '$createDate', '9999-12-31 23:59:59', '', '', '')";

					if ( !$db->Execute($query) )
					{
						// Error on create table
						echo  $db->ErrorMsg()."<br>\n";
						$isErr = True;
					}
				}
			}
			else
			{
				// Show can't open config file templet message
				echo "Can't open the configuration file templet.<br><br><br>";
				$isErr = True;
			}

			// Close the file templet
			@ fclose ($fp);


			// If no error, mean complete the setup process
			if ( !$isErr )
			{
				$isComplete = TRUE;
				session_register("isComplete");
			}
		}

	?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
				<font color="#FF0000" class="title"><b><? echo $COMPLETE ?></b></font>
			</td>
		</tr>
		<tr align="center" valign="top">		
			<td width="100%" align="left">
				<font color="#000000"><? echo $COMPLETE_MSG ?></font>
			</td>
		</tr>
		<tr><td height="5px" class="smalltd">&nbsp;</td></tr>
		<tr>
			<td>
				<font color="#000000">
				<? echo $SYS_URL ?>&nbsp;:&nbsp;<br>
				<a href="<? echo $sess_setupSysURL ?>?"><? echo $sess_setupSysURL ?></a>
				</font>
			</td>
		</tr>
		<tr>
			<td>
				<font color="#000000">
				<? echo $SYS_ADMIN_URL ?>&nbsp;:&nbsp;<br>
				<a href="<? echo $sess_setupSysAdminURL ?>/?"><? echo $sess_setupSysAdminURL ?></a>
				</font>
			</td>
		</tr>
		</table>
	<?
	}
	else
	{ 
		// Show First SETUP page (i.e. $step=0)
	?>
		<table border="0" cellpadding="3" cellspacing="0" width="100%">
		<tr>		
			<td width="100%" height="25px" align="left">
			<? 
				echo '<font color="#000000">'.$THANK_MSG.'</font>&nbsp;<b><font color="#FF0000" class="title">'.$PROGRAM_NAME.'</font></b><br>';
				echo '<font color="#000000">'.$TXT_PROGRAM.'</font>&nbsp;<b><font color="#FF0000" class="title">'.$PROGRAM_VER.'</font></b><br><br>';
				echo '<font color="#000000">'.$STARTUP_MSG.'</font>';
			?>
			</td>
		</tr>
		</table>
	<?
	}
	?>
<!-- End of Script -->

		</td>
	</tr>
	<tr>		
		<td width="100%" height="40" align="center">
		<? 
			if ( $step != 0 && $step != ($MAX_STEP + 1))
			{
		?>
		<input class="button" name="buttonBack" type="submit" value=" <? if ( $show_AGREE_or_DISAGGREE ) echo $BUTTON_DISAGREE; else echo $BUTTON_BACK; ?> " accesskey="b" tabindex="21">
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		<?
			}

			if ( $step == ($MAX_STEP + 1)  &&  $buttonNext)
			{
		?>
		<input class="button" name="buttonComplete" type="submit" value=" <? echo $TXT_COMPLETE; ?> " accesskey="c" tabindex="20">
		<?
			}
			else
			{
		?>
		<input class="button" name="buttonNext" type="submit" <? if ($noNextPage) echo 'disabled="true"';?> value=" <?  if ( $show_AGREE_or_DISAGGREE ) echo $BUTTON_AGREE; else echo $BUTTON_NEXT; ?> " accesskey="n" tabindex="20">
		<?
			}
		?>
		</td>
	</tr>
	</table>
	</td></tr></table>
	</td>
</tr>
</table>
</td></tr></table>
</form>
<font class="login_footer">
<a href="http://openeducation.sourceforge.net/" target="_new"><? echo $PROGRAM_NAME ?></a> -- <? echo $PROGRAM_VER ?><br>
<? echo $TXT_LICENSE ?>
</font>
</center>
</body>
</html>
