<?php
	// File        : /include/sql-table-mysql.inc.php
	//
	// Description : SQL table for MySQL

	// ---------------------------------------------------------- //
	// -------------------     SQL Table       ------------------ //
	// ---------------------------------------------------------- //

	/* 
	*************************************************************************************
	   -= TABLE of 'adm_users' =-
	   1. ac_enable        : 'Y' or 'N' inducate the admin account status
	   2. parent           : inducate the account is create by which admin. Default
							 is '0' mean this a/c create by ROOT admin
	   3. adm_group        : mean the administrator is under which group, it store 
							 the group ID (e.g. '0;1;') [allow mutliple group]
	   4. expire_date_time : The default expire date is '9999-12-31 23:59:59', 
							 mean Nerver Expire.
	   5. modules_allow    : mean the administrator allow to use which modules, it 
							 store the modules ID. (e.g. '1;2;3;4;....')
	*************************************************************************************
	*/
	$DBTABLE_NAME[0] = 'adm_users';
	$CREATETABLE[0]  = "CREATE TABLE $DBTABLE_NAME[0] ( ";
	$CREATETABLE[0] .= "     id               INT UNSIGNED  NOT NULL AUTO_INCREMENT, PRIMARY KEY (id), ";
	$CREATETABLE[0] .= "     ac_enable        CHAR(1)       NOT NULL DEFAULT 'Y', ";
	$CREATETABLE[0] .= "     parent           INT UNSIGNED  NOT NULL DEFAULT '0', ";
	$CREATETABLE[0] .= "     adm_login_id     CHAR(20)      NOT NULL, KEY (adm_login_id), ";
	$CREATETABLE[0] .= "     adm_login_passwd VARCHAR(255)  NOT NULL, ";
	$CREATETABLE[0] .= "     adm_name         VARCHAR(100), ";
	$CREATETABLE[0] .= "     adm_describe     VARCHAR(255), ";
	$CREATETABLE[0] .= "     adm_email        VARCHAR(255), ";
	$CREATETABLE[0] .= "     adm_group        VARCHAR(255), ";
	$CREATETABLE[0] .= "     default_lang     CHAR(20)      DEFAULT 'EN', ";
	$CREATETABLE[0] .= "     default_themes   VARCHAR(255), ";
	$CREATETABLE[0] .= "     create_date      DATETIME      NOT NULL DEFAULT '9999-12-31 23:59:59', ";
	$CREATETABLE[0] .= "     expire_date_time DATETIME      NOT NULL DEFAULT '9999-12-31 23:59:59', ";
	$CREATETABLE[0] .= "     ip_access_list   VARCHAR(255), ";
	$CREATETABLE[0] .= "     ip_deny_list     VARCHAR(255), ";
	$CREATETABLE[0] .= "     modules_allow    TEXT ";
	$CREATETABLE[0] .= ");";



	/* 
	***************************************************************************
	   -= TABLE of 'group' =-
	   This table only store the admin group information. It is used to seperate
	   the administrator with different permission setting.
	***************************************************************************
	*/
	$DBTABLE_NAME[1] = 'oes_group';
	$CREATETABLE[1]  = "CREATE TABLE $DBTABLE_NAME[1] ( ";
	$CREATETABLE[1] .= "     id               INT UNSIGNED  NOT NULL AUTO_INCREMENT, PRIMARY KEY (id), ";
	$CREATETABLE[1] .= "     group_enable     CHAR(1)       NOT NULL DEFAULT 'Y', ";
	$CREATETABLE[1] .= "     group_name       VARCHAR(255)  NOT NULL, ";
	$CREATETABLE[1] .= "     group_describe   VARCHAR(255) ";
	$CREATETABLE[1] .= ");";



	/* 
	***************************************************************************
	   -= TABLE of 'log' =-
	   This table used to store all the system log, including user login, 
	   logout, download, post message ...etc.

       1. log_code     : the event code (see the event_map.txt)
	***************************************************************************
	*/
	$DBTABLE_NAME[2] = 'log';
	$CREATETABLE[2]  = "CREATE TABLE $DBTABLE_NAME[2] ( ";
	$CREATETABLE[2] .= "     id               INT UNSIGNED  NOT NULL AUTO_INCREMENT, PRIMARY KEY (id), ";
	$CREATETABLE[2] .= "     log_code         INT(4) UNSIGNED  NOT NULL DEFAULT '1', ";
	$CREATETABLE[2] .= "     log_time         DATETIME      NOT NULL DEFAULT '9999-12-31 23:59:59', ";
	$CREATETABLE[2] .= "     log_event        TEXT          NOT NULL, ";
	$CREATETABLE[2] .= "     log_user_id      VARCHAR(255)  ";
	$CREATETABLE[2] .= ");";



	// ---------------------------------------------------------- //
	// -------------------  End of SQL Table   ------------------ //
	// ---------------------------------------------------------- //
?>